"use strict";

jQuery(function($) {
    $(document).ready(function() {

        function smwpcb_escape_html_attr(unsafe) {
            return unsafe.replace(/&amp;/g, "&").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&quot;/g, '"').replace(/&#039;/g, "'");
        }
        function smwpcb_escape_html(unsafe) {
            return unsafe.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#039;");
        }
        function smwpcb_some_tags_to_html( string ) {
            var stringreturned = '';
            var eachLine = string.split('\n');
            for (var j = 0; j < eachLine.length; j++) {
                var found_strong = false;
                for(var i=0; i<eachLine[j].length-1; i++) {
                    var char = eachLine[j][i];
                    var next_char = eachLine[j][i+1];
                    if(char == '*' && next_char == '*') {
                        var strong = (!(found_strong) ? '<strong>' : '</strong>');
                        eachLine[j] = eachLine[j].slice(0,i) + strong + eachLine[j].slice(i);
                        i = i + strong.length;
                        found_strong = (!found_strong) ? true : false;
                    }
                }
            stringreturned += eachLine[j] + ((j != eachLine.length-1) ? '<br>' : '');
            }
            return stringreturned;
        }

        $('.editDataColumn').on('click', function(event) {
            $(this).closest('tr').find('input').each(function() {
                $(this).attr('type', 'text');
            });
            $(this).closest('tr').find('span').each(function() {
                $(this).remove();
            });
            event.preventDefault();
            event.stopPropagation();

        });

        $('.smwpcb_users_data').on('click', '.editDataUser', function(event) {
            $('.smwpcb_table_fix').css('white-space', 'nowrap');
            $('.smwpcb_table_fix').css('table-layout', 'fixed');
            $('.smwpcb_table_fix td').css('overflow', 'hidden');
            var idKey = $(this).attr('key');
            var outputedStr = `
	      <tr class="inline-edit-row quick-edit-row-page">
	      <td colspan="` + (smwpcb_data_tables_settings.length + 3) + `" class="colspanchange">
	      <fieldset class="inline-edit-col-left">
	          <legend class="inline-edit-legend">Edit</legend>
	          <div class="inline-edit-col">`;
            var i = 0;
            $(this).closest('tr').find('input[type="hidden"]').each(function() {
                if (i < smwpcb_data_tables_settings.length) {
                    outputedStr += `
	          <label>
	              <span class="title" style="padding-right:3em;">` + smwpcb_data_tables_settings[i]['name'] + `</span>
	              <span class="input-text-wrap">
	              <input type="text" class="ptitle" value="` + smwpcb_sanitize_text_field($(this).val()).smwpcb_replace_all("\\", "").smwpcb_replace_all("<br>", "\n").smwpcb_replace_all("\"", "") + `">
	              <input type="hidden" value="` + smwpcb_sanitize_text_field($(this).val()).smwpcb_replace_all("\\", "").smwpcb_replace_all("<br>", "\n").smwpcb_replace_all("\"", "") + `">
	              </span>
	          </label>`;
                } else {
                    outputedStr += `
	          <label>
	              <span class="title" style="padding-right:3em;">Users responses</span>
	              <span class="input-text-wrap">
	              <textarea rows="3" class="ptitle" >` + smwpcb_sanitize_text_field($(this).val()).smwpcb_replace_all("\\", "").smwpcb_replace_all("<br>", "\n").smwpcb_replace_all("\"", "") + `</textarea>
	              <input type="hidden" value="` + smwpcb_sanitize_text_field($(this).val()).smwpcb_replace_all("\\", "").smwpcb_replace_all("<br>", "\n").smwpcb_replace_all("\"", "") + `">
	              </span>
	          </label>`;
                }
                i++;
            });
            outputedStr += `
	          </div>
	          </fieldset>

	            <div class="submit inline-edit-save">
	                <button type="button" idKey="` + idKey + `" date="` + $(this).closest('td').find('.datetitle').text() + `" dateTitle="` + $(this).closest('td').find('.datetitle').attr('title') + `" class="button cancelDataUser alignleft">Cancel</button>
	                <button type="button" idKey="` + idKey + `" date="` + $(this).closest('td').find('.datetitle').text()+`" dateTitle="` + $(this).closest('td').find('.datetitle').attr('title') + `" class="button-primary alignright saveDataUser">Update</button>
	                <span class="spinner"></span>
	                <br class="clear">
	                <div class="notice notice-error notice-alt inline hidden">
	                    <p class="error"></p>
	                </div>
	            </div>
	        </td>
	        </tr>`;

            $(this).closest('tr').replaceWith(outputedStr);
            event.preventDefault();
            event.stopPropagation();
        });

        $('.smwpcb_users_data').on('click', '.saveDataUser', function() {
            var buttn = $(this);
            var idKey = $(this).attr('idKey');
            var dtArr = [];
            var Outstr = `<tr>
	        <th scope="row" class="check-column">
	            <input type="checkbox">
	        </th>
	        <td><strong><a title="` + $(this).attr('dateTitle') + `" href="javascript:void(0)" key="` + idKey + `" class="editDataUser datetitle">` + $(this).attr('date') + `</a></strong>
	            <div class="row-actions">
	              <span class="edit">
	                <a href="javascript:void(0)" key="` + idKey + `" class="editDataUser">Edit</a> | </span>
	              <span class="trash">
	                <a href="javascript:void(0)" key="` + idKey + `" class="deleteDataUser">Trash</a> </span>
	            </div>
	        </td>`;
            $(this).closest('td').find('.spinner').css('visibility', 'visible');
            $(this).closest('td').find('input[type="text"],textarea').each(function() {
                dtArr.push(smwpcb_sanitize_text_field($(this).val()).smwpcb_replace_all("\\", "").smwpcb_replace_all("\"", ""));
            });
            for (var i = 0; i < smwpcb_data_tables_settings.length + 1; i++) {
                Outstr += `
	            <td>
	              <span>` + smwpcb_some_tags_to_html(dtArr[i]).smwpcb_replace_all("\\", "").smwpcb_replace_all("**", "").smwpcb_replace_all("\"", "") + `</span>
	              <input type="hidden" value="` + dtArr[i].smwpcb_replace_all("\\", "").smwpcb_replace_all("\"", "") + `">
	            </td>`;
            }
            Outstr += `</tr>`;
            var data = {
                'action': 'smwpcb_save_data_user_action',
                'savedData': [idKey, dtArr]
            };
            jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data).done(function(msg) {
                buttn.closest('tr').replaceWith(Outstr);
                $('.smwpcb_table_fix').css('table-layout', 'unset');
                $('.smwpcb_table_fix td').css('overflow', 'unset');
                $('.smwpcb_table_fix').css('white-space', 'unset');
            }).fail(function(xhr, textStatus, errorThrown) {
                buttn.closest('td').find('.error').html("Something went wrong, check your internet connection");
                buttn.closest('td').find('.notice-error').removeClass('hidden');
                buttn.closest('td').find('.spinner').css('visibility', 'hidden');
            });
        });

        $('.smwpcb_users_data').on('click', '.cancelDataUser', function() {
            var buttn = $(this);
            var idKey = $(this).attr('idKey');
            var dtArr = [];
            var Outstr = `<tr>
	        <th scope="row" class="check-column">
	            <input type="checkbox">
	        </th>
	        <td><strong><a title="` + $(this).attr('dateTitle') + `" href="javascript:void(0)" key="` + idKey + `" class="editDataUser datetitle">` + $(this).attr('date') + `</a></strong>
	            <div class="row-actions">
	              <span class="edit">
	                <a href="javascript:void(0)" key="` + idKey + `" class="editDataUser">Edit</a> | </span>
	              <span class="trash">
	                <a href="javascript:void(0)" key="` + idKey + `" class="deleteDataUser">Trash</a> </span>
	            </div>
	        </td>`;
            $(this).closest('td').find('input[type="hidden"]').each(function() {
                dtArr.push(smwpcb_sanitize_text_field($(this).val()).smwpcb_replace_all("\\", "").smwpcb_replace_all("\"", ""));
            });
            for (var i = 0; i < smwpcb_data_tables_settings.length + 1; i++) {
                Outstr += `
	            <td>
	              <span>` + smwpcb_some_tags_to_html(dtArr[i]).smwpcb_replace_all("**", "").smwpcb_replace_all("\\", "") + `</span>
	              <input type="hidden" value="` + dtArr[i].smwpcb_replace_all("\\", "").smwpcb_replace_all("\"", "") + `">
	            </td>`;
            }
            Outstr += `</tr>`;
            buttn.closest('tr').replaceWith(Outstr);
            $('.smwpcb_table_fix').css('table-layout', 'unset');
            $('.smwpcb_table_fix td').css('overflow', 'unset');
            $('.smwpcb_table_fix').css('white-space', 'unset');
        });

        $('#the-list').on('click', '.deleteDataUser', function(event) {
            if (window.confirm("Are you sure to continue ?")) {
                var idKey = $(this).attr('iduser');
                var data = {
                    'action': 'smwpcb_delete_data_user_action',
                    'deleted_key': idKey
                };
                jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                    history.go(0);
                });
            }
            event.preventDefault();
            event.stopPropagation();

        });

        function smwpcb_parse_hash(hash) {
            hash = hash.substring(1, hash.length);

            var hashObj = [];

            hash.split('&').forEach(function(q) {
                if (typeof q !== 'undefined') {
                    hashObj.push(q);
                }
            });

            return hashObj;
        }

        var smwpcb_urlHash = 'smwpcb-ps';
        var smwpcb_focusObj = false;
        var smwpcb_urlHashArr = smwpcb_parse_hash(window.location.hash);

        if (smwpcb_urlHashArr[0] !== '') {
            smwpcb_urlHash = smwpcb_urlHashArr[0];
        }
        if (smwpcb_urlHashArr[1] !== "undefined") {
            smwpcb_focusObj = smwpcb_urlHashArr[1];
        }
        var smwpcb_activeTab = "";
        $('a.nav-tab, a.smwpcb_next_tab').on('click',function(e) {
            if ($(this).attr('data-tab-name') !== smwpcb_activeTab) {
                $('div.smwpcb-tab-container[data-tab-name="' + smwpcb_activeTab + '"]').hide();
                $('a.nav-tab[data-tab-name="' + smwpcb_activeTab + '"]').removeClass('nav-tab-active');
                smwpcb_activeTab = $(this).attr('data-tab-name');
                $('div.smwpcb-tab-container[data-tab-name="' + smwpcb_activeTab + '"]').show();
                $(this).addClass('nav-tab-active');
                if (window.location.hash !== smwpcb_activeTab) {
                    window.location.hash = smwpcb_activeTab;
                }
                if (smwpcb_focusObj) {
                    $('html, body').animate({
                        scrollTop: $('#' + smwpcb_focusObj).offset().top
                    }, 'fast', function() {
                        $('#' + smwpcb_focusObj).focus();
                        smwpcb_focusObj = false;
                    });
                }
            }
        });
        $('a.nav-tab[data-tab-name="' + smwpcb_urlHash + '"]').trigger('click');

        $('.addmoreprAg').on('keydown', '#smwpcb_column_table_variable', function(e) {
            if (e.keyCode == 32)
                e.preventDefault();
        });

        $('#add_new_agent').on('click',function() {
            if ($('.addmoreprAg').css('display') == 'none') {
                $('.addmoreprAg').css('display', 'block');
                $('.addmoreprAg').find('input[type="text"],textarea').each(function() {
                    $(this).val('');
                });
                $('.addmoreprAg').find('.smwpcb_add_to_validation_msg,.valmsgdescription').each(function() {
                    $(this).css('display', 'none');
                });
                $('.addmoreprAg').find('.smwpcb_switch_toggle input').each(function() {
                    $(this).prop('checked', false);
                });
                $('#smwpcb_chatbot_project_widget').prop('checked', true);
                $('.smwpcb_toggle_validation').css('display', 'none');
                $('#smwpcb_chatbot_project_topic').val('');
                $('#smwpcb_chatbot_project_widget_page').val('');

                if ($('.addmoreprAg .button-primary').val().indexOf("Edit") >= 0) {
                    $('.addmoreprAg .button-primary').val('Please Refresh Page to add new');
                    $('.addmoreprAg .button-primary').prop('disabled', true);
                }

            } else {
                $('.addmoreprAg').css('display', 'none');
                $('.addmoreprAg').find('input[type="text"],textarea').each(function() {
                    $(this).val('');
                });
                $('.addmoreprAg').find('.smwpcb_add_to_validation_msg,.valmsgdescription').each(function() {
                    $(this).css('display', 'none');
                });
                $('.addmoreprAg').find('.smwpcb_switch_toggle input').each(function() {
                    $(this).prop('checked', false);
                });
                $('#smwpcb_chatbot_project_widget').prop('checked', true);
                $('.smwpcb_toggle_validation').css('display', 'none');
                $('#smwpcb_chatbot_project_topic').val('');
                $('#smwpcb_chatbot_project_widget_page').val('');
                if ($('.addmoreprAg .button-primary').val().indexOf("Edit") >= 0) {
                    $('.addmoreprAg .button-primary').val('Please Refresh Page to add new');
                    $('.addmoreprAg .button-primary').prop('disabled', true);
                }
            }
        });

        $('.addmoreprAg').on('click', '.cancelsubmit', function() {
            $('.addmoreprAg').css('display', 'none');
            $('.addmoreprAg').find('input[type="text"],textarea').each(function() {
                $(this).val('');
            });
            $('.addmoreprAg').find('.smwpcb_add_to_validation_msg,.valmsgdescription').each(function() {
                $(this).css('display', 'none');
            });
            $('.addmoreprAg').find('.smwpcb_switch_toggle input').each(function() {
                $(this).prop('checked', false);
            });
            $('#smwpcb_chatbot_project_widget').prop('checked', true);
            $('.smwpcb_toggle_validation').css('display', 'none');
            $('#smwpcb_chatbot_project_topic').val('');
            $('#smwpcb_chatbot_project_widget_page').val('');
            if ($('.addmoreprAg .button-primary').val().indexOf("Edit") >= 0) {
                $('.addmoreprAg .button-primary').val('Please Refresh Page to add new');
                $('.addmoreprAg .button-primary').prop('disabled', true);
            }
        });

        $('.updatecbAgent').on('click', function(event) {
            $('#addmoreagent').css('display', 'block');
            var idKey = $(this).attr('idkey');
            var button = $(this);
            $('#smwpcb_chatbots_name').val(smwpcb_escape_html_attr(button.closest(".smwpcb_the_available_agents").find(".smwpcb_chatbot_nm").text()).smwpcb_replace_all("\\", ""));
            $('#smwpcb_avatar_attachment_id').val(smwpcb_escape_html_attr(button.closest(".smwpcb_the_available_agents").find(".smwpcb_the_available_agents_image_id").val()));
            $('#smwpcb_chatbots_occupation').val(smwpcb_escape_html_attr(button.closest(".smwpcb_the_available_agents").find(".smwpcb_chatbot_occup").text()).smwpcb_replace_all("\\", ""));
            $('#smwpcb_chatbots_description').val(smwpcb_escape_html_attr(button.closest(".smwpcb_the_available_agents").find(".smwpcb_chatbot_desc").text()).smwpcb_replace_all("\\", ""));
            $('p.submit').replaceWith(`
	        <p class="submit">
	          <input type="hidden" name="smwpcb_edit_key" value="` + idKey + `" />
	          <button type="button" class="button cancelsubmit" id="cancelagentsubmit">Cancel</button>
	          <input type="submit" class="button-primary" name="edit_page_chatbot_agents_settings" id="smwpcb_edit_tpc" value="Edit Agent" />
	        </p>
	        `);
        });

        $('.updatecbTopic').on('click', function(event) {
            var idkey = $(this).attr('idkey');
            $('#addmoreagent').css('display', 'block');
            $("html, body").animate({
                scrollTop: 0
            }, "slow");
            $('#smwpcb_topic_name').attr('value', smwpcb_escape_html_attr($('.tabrw' + idkey + ' td strong').html()).smwpcb_replace_all("\\", ""));
            $('#smwpcb_topic_description').attr('value', smwpcb_escape_html_attr($('.tabrw' + idkey + ' td.column-description p').html()).smwpcb_replace_all("\\", ""));
            $('p.submit').replaceWith(`
	        <p class="submit">
	          <input type="hidden" name="smwpcb_edit_topic_key" value="` + idkey + `" />
	          <input type="submit" class="button-primary" name="edit_page_chatbot_topics_settings" value="Edit Topic" />
	          <button type="button" class="button cancelsubmit" id="cancelagentsubmit">Cancel</button>
	        </p>
	        `);
            event.preventDefault();
            event.stopPropagation();
        });

        $('.updatecbSettingsTopic').on('click', function(event) {
            var idkey = $(this).attr('idkey');
            $(location).attr('href', 'admin.php?page=smwpcb_wp_chatbot_topics&action=edit&topic=' + idkey);
            event.preventDefault();
            event.stopPropagation();
        });

        $('.deletecbAgent').on('click', function(event) {
            if (window.confirm("Are you sure you want to delete this agent ?")) {
                var idKey = $(this).attr('idkey');
                var data = {
                    'action': 'smwpcb_delete_agent_action',
                    'deleted_key': idKey
                };
                jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                    history.go(0);
                });
            }

        });

        $('.deletecbTopic').on('click', function(event) {
            if (window.confirm("Are you sure you want to delete this topic ?")) {
                var idKey = $(this).attr('idkey');
                var data = {
                    'action': 'smwpcb_delete_topic_action',
                    'deleted_key': idKey
                };
                jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                    history.go(0);
                });
            }
            event.preventDefault();
            event.stopPropagation();

        });

        $('#applytopics').on('click', function(event) {
            if ($('#bulk-action-selector-top').val() == "delete-selected-topic") {
                if (window.confirm("Are you sure you want to proceed on action ?")) {
                    var keyArray = [];
                    $('.checkedTopic').each(function() {
                        if ($(this).is(':checked')) {
                            keyArray.push($(this).val());
                        }
                    });
                    var data = {
                        'action': 'smwpcb_delete_apply_topic_action',
                        'deleted_keys': keyArray
                    };
                    jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                        history.go(0);
                    });
                }
                event.preventDefault();
                event.stopPropagation();
            }

        });

        $('#applyUserData').on('click', function(event) {
            if ($('#bulk-action-selector-top').val() == "delete-selected-data-users") {
                if (window.confirm("Are you sure you want to proceed on action ?")) {
                    var keyArray = [];
                    $('.checkedUserData').each(function() {
                        if ($(this).is(':checked')) {
                            keyArray.push($(this).val());
                        }
                    });
                    var data = {
                        'action': 'smwpcb_delete_apply_user_data_action',
                        'deleted_keys': keyArray
                    };
                    jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                        history.go(0);
                    });
                }
                event.preventDefault();
                event.stopPropagation();
            }

        });

        $('#applyChatBotProject').on('click', function(event) {
            if ($('#bulk-action-selector-top').val() == "delete-selected-project") {
                if (window.confirm("Are you sure you want to proceed on action ?")) {
                    var keyArray = [];
                    $('.checkedProject').each(function() {
                        if ($(this).is(':checked')) {
                            keyArray.push($(this).val());
                        }
                    });
                    var data = {
                        'action': 'smwpcb_delete_apply_project_action',
                        'deleted_keys': keyArray
                    };
                    jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                        history.go(0);
                    });
                }
                event.preventDefault();
                event.stopPropagation();
            }

        });

        $('#applyColumnTable').on('click', function(event) {
            if ($('#bulk-action-selector-top').val() == "delete-selected-column-table") {
                if (window.confirm("Are you sure you want to proceed on action ?")) {
                    var keyArray = [];
                    $('.checkedColumnTable').each(function() {
                        if ($(this).is(':checked')) {
                            keyArray.push($(this).val());
                        }
                    });
                    var data = {
                        'action': 'smwpcb_delete_apply_column_table_action',
                        'deleted_keys': keyArray
                    };
                    jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                        history.go(0);
                    });
                }
                event.preventDefault();
                event.stopPropagation();
            }

        });

        $('#smwpcb_cb_ui_custom').on('click', function(event) {
            $(this).text('loading...');
            function smwpcb_helper_color_function(hex, lum) {
                hex = String(hex).replace(/[^0-9a-f]/gi, '');
                if (hex.length < 6) {
                    hex = hex[0] + hex[0] + hex[1] + hex[1] + hex[2] + hex[2];
                }
                lum = lum || 0;
                var rgb = "#",
                    c, i;
                for (i = 0; i < 3; i++) {
                    c = parseInt(hex.substr(i * 2, 2), 16);
                    c = Math.round(Math.min(Math.max(0, c + (c * lum)), 255)).toString(16);
                    rgb += ("00" + c).substr(c.length);
                }
                return rgb;
            }
            var postedData = {};
            postedData['smwpcb_prime_width'] = smwpcb_sanitize_text_field($('#smwpcb_prime_width').val());
            postedData['smwpcb_prime_icon_size'] = smwpcb_sanitize_text_field($('#smwpcb_prime_icon_size').val());
            postedData['smwpcb_prime_icon_msg'] = smwpcb_sanitize_text_field($('#smwpcb_prime_icon_msg').val());
            postedData['smwpcb_prime_icon_x'] = smwpcb_sanitize_text_field($('#smwpcb_prime_icon_x').val());
            postedData['smwpcb_message_sound'] = smwpcb_sanitize_text_field($('#smwpcb_message_sound').val());
            postedData['smwpcb_chat_pos_right'] = smwpcb_sanitize_text_field($('#smwpcb_chat_pos_right').val());
            postedData['smwpcb_chat_pos_right_chat'] = smwpcb_sanitize_text_field($('#smwpcb_chat_pos_right_chat').val());
            postedData['smwpcb_chat_pos_bottom'] = smwpcb_sanitize_text_field($('#smwpcb_chat_pos_bottom').val());
            postedData['smwpcb_chat_pos_bottom_chat'] = smwpcb_sanitize_text_field($('#smwpcb_chat_pos_bottom_chat').val());
            postedData['smwpcb_chat_font_size'] = smwpcb_sanitize_text_field($('#smwpcb_chat_font_size').val());
            postedData['smwpcb_chat_line_height'] = smwpcb_sanitize_text_field($('#smwpcb_chat_line_height').val());
            postedData['smwpcb_chat_font_weight'] = smwpcb_sanitize_text_field($('#smwpcb_chat_font_weight').val());
            postedData['smwpcb_prime_background'] = smwpcb_sanitize_text_field($('#smwpcb_prime_background').val());
            postedData['smwpcb_prime_font_color'] = smwpcb_sanitize_text_field($('#smwpcb_prime_font_color').val());
            postedData['smwpcb_prime_font_color_hover'] = smwpcb_sanitize_text_field($('#smwpcb_prime_font_color_hover').val());
            postedData['smwpcb_chat_conversation_bg'] = smwpcb_sanitize_text_field($('#smwpcb_chat_conversation_bg').val());
            postedData['smwpcb_chat_conversation_bg_bot'] = smwpcb_sanitize_text_field($('#smwpcb_chat_conversation_bg_bot').val());
            postedData['smwpcb_chat_conversation_bg_user'] = smwpcb_sanitize_text_field($('#smwpcb_chat_conversation_bg_user').val());
            postedData['smwpcb_chat_conversation_color'] = smwpcb_sanitize_text_field($('#smwpcb_chat_conversation_color').val());
            postedData['smwpcb_chat_conversation_color_bot'] = smwpcb_sanitize_text_field($('#smwpcb_chat_conversation_color_bot').val());
            postedData['smwpcb_chat_conversation_color_user'] = smwpcb_sanitize_text_field($('#smwpcb_chat_conversation_color_user').val());
            postedData['smwpcb_chat_conversation_bg_user_darker'] = smwpcb_helper_color_function(smwpcb_sanitize_text_field($('#smwpcb_chat_conversation_bg_user').val()), -0.20);
            var data = {
                'action': 'smwpcb_cb_ui_custom_action',
                'postedData': postedData
            };
            jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                $(location).attr('href', 'admin.php?page=smwpcb_wp_design_chatbot_ui&saved=1');
                window.scrollTo(0, 0);
            });

            event.preventDefault();
            event.stopPropagation();

        });

        $(".cb_ui_custom_setDefault").on('click', function(event) {
            switch ($(this).attr('key')) {
                case "1":
                    $('#smwpcb_prime_width').val('70');
                    $('#smwpcb_prime_icon_size').val('32');
                    $('#smwpcb_prime_icon_msg').val('f261');
                    $('#smwpcb_prime_icon_x').val('f136');
                    $('#smwpcb_message_sound').val('when.mp3');
                    break;
                case "2":
                    $('#smwpcb_chat_pos_right').val('16');
                    $('#smwpcb_chat_pos_right_chat').val('16');
                    $('#smwpcb_chat_pos_bottom').val('16');
                    $('#smwpcb_chat_pos_bottom_chat').val('90');
                    $('#smwpcb_chat_font_size').val('15');
                    $('#smwpcb_chat_line_height').val('19');
                    $('#smwpcb_chat_font_weight').val('600');
                    break;
                case "3":
                    $('#smwpcb_prime_background').val('#2f3037');
                    $('#smwpcb_prime_font_color').val('#f0f0f0');
                    $('#smwpcb_prime_font_color_hover').val('#f33462');
                    $('#smwpcb_chat_conversation_bg').val('#e9e9e9');
                    $('#smwpcb_chat_conversation_bg_bot').val('#ffffff');
                    $('#smwpcb_chat_conversation_bg_user').val('#f33462');
                    $('#smwpcb_chat_conversation_color').val('#585858');
                    $('#smwpcb_chat_conversation_color_bot').val('#000000');
                    $('#smwpcb_chat_conversation_color_user').val('#fef1f2');
                    break;

            }
            event.preventDefault();
            event.stopPropagation();

        });

        $('#smwpcb_ringtone_listen').on('click', function(e){
            e.preventDefault();
            var smwpcb_audio = new Audio(smwpcb_custom_ui_wp_link.audio_path + "/" + $('#smwpcb_message_sound').val());
            smwpcb_audio.play();
        })

        $('#smwpcb_chatbots_conversation_starter').on('click',function() {
            if ($(this).is(':checked')) {
                $('#conversation_starter_toggle').css('display', 'table-row');
            } else {
                $('#conversation_starter_toggle').css('display', 'none');
            }
        });

        $('#smwpcb_chatbots_use_google_api').on('click',function() {
            if ($(this).is(':checked')) {
                $('.use_api_toggle').css('display', 'table-row');
            } else {
                $('.use_api_toggle').css('display', 'none');
            }
        });

        $('.updatecbproject').on('click', function(event) {
            var idKey = $(this).attr('key');
            var updatepr = $(this);
            var updatetext = $(this).text();
            var data = {
                'action': 'smwpcb_get_updated_project',
                'project_id': idKey
            };
            updatepr.text('loading..');
            var smwpcb_wp_chatbot_projects = '';
            jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                smwpcb_wp_chatbot_projects = JSON.parse(data);
                $('#smwpcb_chatbot_project_name').val(smwpcb_wp_chatbot_projects['smwpcb_chatbot_project_name'].smwpcb_replace_all("\\", ""));
                $('#smwpcb_chatbot_project_topic').val(smwpcb_wp_chatbot_projects['smwpcb_chatbot_project_topic'].smwpcb_replace_all("\\", ""));
                $('#smwpcb_chatbot_project_agent').val(smwpcb_wp_chatbot_projects['smwpcb_chatbot_project_agent'].smwpcb_replace_all("\\", ""));
                if (smwpcb_wp_chatbot_projects['smwpcb_chatbot_project_shortcode'] == 'Yes') {
                    $('#smwpcb_chatbot_project_shortcode').prop('checked', true);
                }else{
                    $('#smwpcb_chatbot_project_shortcode').prop('checked', false);
                }
                $('#smwpcb_chatbot_project_widget_page').val(smwpcb_wp_chatbot_projects['smwpcb_chatbot_project_widget_page']);
                $('#smwpcb_chatbot_project_widget_page option[value="' + smwpcb_wp_chatbot_projects['smwpcb_chatbot_project_widget_page'] + '"]').prop('disabled', false);
                $('p.submit').replaceWith(`
        	        <p class="submit">
        	          <input type="hidden" name="smwpcb_edit_project_key" value="` + idKey + `" />
        	          <button type="button" class="button cancelsubmit" id="cancelagentsubmit">Cancel</button>
        	          <input type="submit" class="button-primary" name="edit_page_chatbots_projects" id="edit_page_chatbots_projects" value="Edit Project" />
        	        </p>
        	    `);
                $('.addmoreprAg').css('display', 'block');
                updatepr.text(updatetext.smwpcb_replace_all("\\", ""));
            });
        });

        $('.deletecbproject').on('click', function(event) {
            if (window.confirm("Are you sure you want to delete this project ?")) {
                var idKey = $(this).attr('key');
                var data = {
                    'action': 'smwpcb_delete_project_action',
                    'deleted_key': idKey
                };
                jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                    history.go(0);
                });
            }

        });

        $('.updatecbcolumn').on('click', function(event) {
            var idKey = $(this).attr('key');
            var updatepr = $(this);
            var updatetext = $(this).text();
            var smwpcb_wp_chatbot_column = '';
            var data = {
                'action': 'smwpcb_get_updated_column',
                'column_id': idKey
            };
            updatepr.text('loading..');
            jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                smwpcb_wp_chatbot_column = JSON.parse(data);
                $('#smwpcb_column_table_name').val(smwpcb_escape_html_attr(smwpcb_wp_chatbot_column['name']).smwpcb_replace_all("\\", ""));
                $('#smwpcb_column_table_variable').val(smwpcb_escape_html_attr(smwpcb_wp_chatbot_column['variable']).smwpcb_replace_all("\\", ""));
                if (smwpcb_wp_chatbot_column['column_validation'] != '') {
                    $('#smwpcb_column_table_validation').val(smwpcb_escape_html_attr(smwpcb_wp_chatbot_column['column_validation']).smwpcb_replace_all("\\", ""));
                    $('#smwpcb_column_table_validation_msg').val(smwpcb_escape_html_attr(smwpcb_wp_chatbot_column['column_validation_msg']).smwpcb_replace_all("\\", ""));
                    $('#smwpcb_column_table_validation').prop('checked', true);
                    $('.smwpcb_toggle_validation').css('display', 'block');
                    var arrayOfCols = smwpcb_escape_html_attr(smwpcb_wp_chatbot_column['column_validation_msg']).smwpcb_replace_all("\\", "").split("|6^9~");
                    $('.smwpcb_add_to_validation').each(function(index) {
                        if (smwpcb_wp_chatbot_column['column_validation'].indexOf($(this).val()) >= 0) {
                            $(this).prop('checked', true);
                            $(this).closest('div').find('.smwpcb_add_to_validation_msg').css('display', 'block');
                            $(this).closest('div').find('.smwpcb_add_to_validation_msg').val(arrayOfCols[index]);
                            $(this).closest('.smwpcb_validation_unit').find('.valmsgdescription').css('display', 'block');
                        } else {
                            $(this).prop('checked', false);
                            $(this).closest('div').find('.smwpcb_add_to_validation_msg').css('display', 'none');
                            $(this).closest('div').find('.smwpcb_add_to_validation_msg').val('');
                            $(this).closest('.smwpcb_validation_unit').find('.valmsgdescription').css('display', 'none');
                        }
                    });

                } else {
                    $('#smwpcb_column_table_validation').prop('checked', false);
                    $('.smwpcb_toggle_validation').css('display', 'none');
                    $('#smwpcb_column_table_validation_msg').val('');
                }

                $('p.submit').replaceWith(`
        	        <p class="submit">
        	          <input type="hidden" name="smwpcb_edit_column_key" value="` + idKey + `" />
        	          <button type="button" class="button cancelsubmit" id="cancelagentsubmit">Cancel</button>
        	          <input type="submit" class="button-primary" name="edit_page_chatbots_data_tables" id="edit_page_chatbots_projects" value="Edit Column Data" />
        	        </p>
        	        `);
                $('.addmoreprAg').css('display', 'block');
                updatepr.text(updatetext);
            });
        });

        $('.deletecbcolumn').on('click', function(event) {
            if (window.confirm("Are you sure you want to delete this column ?")) {
                var idKey = $(this).attr('key');
                var data = {
                    'action': 'smwpcb_delete_column_action',
                    'deleted_key': idKey
                };
                jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                    history.go(0);
                });
            }

        });

        $('.smwpcb_add_to_validation').on('click', function() {
            if ($(this).is(':checked')) {
                $(this).closest('div').find('.smwpcb_add_to_validation_msg').css('display', 'block');
                $(this).closest('.smwpcb_validation_unit').find('.valmsgdescription').css('display', 'block');
            } else {
                $(this).closest('div').find('.smwpcb_add_to_validation_msg').css('display', 'none');
                $(this).closest('.smwpcb_validation_unit').find('.valmsgdescription').css('display', 'none');
            }

        });

        $('#smwpcb_column_table_validation').on('click',function() {
            if ($(this).is(':checked')) {
                $('.smwpcb_toggle_validation').css('display', 'block');
            } else {
                $('.smwpcb_toggle_validation').css('display', 'none');
            }
        });

        $('#smwpcb_addcodelicence').on('click',function() {
            var disabled = $(this);
            disabled.attr('disabled', true);
            $('.smwpcb_code_licences').append(`<br><input type="text" style="width:320px" name="smwpcb_code_licence` + $('.smwpcb_code_licences').attr('itemkeys') + `" placeholder="xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" value="" required>
	                    <button type="button" class="button smwpcb_deletecodelicence" idkey="` + $('.smwpcb_code_licences').attr('itemkeys') + `" >Delete</button>`);

            var data = {
                'action': 'smwpcb_add_code_licence_action',
                'itemkeys': $('.smwpcb_code_licences').attr('itemkeys')
            };
            jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                $('.smwpcb_code_licences').attr('itemkeys', parseInt($('.smwpcb_code_licences').attr('itemkeys')) + 1);
                disabled.attr('disabled', false);
            });


        });

        $('.wrap').on('click', '.smwpcb_deletecodelicence', function() {
            $('.smwpcb_deletecodelicence').attr('disabled', true);
            var self = $(this);
            var idKey = self.attr('idkey');
            var data = {
                'action': 'smwpcb_delete_code_licence_action',
                'deleted_key': idKey
            };
            if (self.prev().val() != '') {
                if (window.confirm("Are you sure you want to delete this code licence ?")) {
                    jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                        self.prev().remove();
                        self.prev().remove();
                        self.remove();
                        $('.smwpcb_deletecodelicence').attr('disabled', false);
                    });
                } else {
                    $('.smwpcb_deletecodelicence').attr('disabled', false);
                }
            } else {
                jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data, function(data) {
                    $('.smwpcb_deletecodelicence').attr('disabled', false);
                    self.prev().remove();
                    self.prev().remove();
                    self.remove();
                });
            }


        });

        $('.wrap').on('click', '#smwpcb_gotosettings', function() {
            $(location).attr('href', 'admin.php?page=smwpcb_wp_chatbot_general_settings');
        });

        $('.smwpcb_tab_extended').on('click',function() {
            $('.smwpcb_tab_extended').removeClass('smwpcb_tab_active');
            $(this).addClass('smwpcb_tab_active');
            var active_tab_key = $('.smwpcb_tab_extended.smwpcb_tab_active').data('option');
            $('.smwpcb_settings_wrapper').removeClass('smwpcb_tab_active_container');
            $('.smwpcb_settings_wrapper[data-option-ref="' + active_tab_key + '"]').addClass('smwpcb_tab_active_container');
        });

        $('.smwpcb_next_tab_extended').on('click',function() {
            $('.smwpcb_tab_extended').removeClass('smwpcb_tab_active');
            var active_tab_key = $(this).data('option');
            $('li[data-option="' + active_tab_key + '"]').addClass('smwpcb_tab_active');
            $('.smwpcb_settings_wrapper').removeClass('smwpcb_tab_active_container');
            $('.smwpcb_settings_wrapper[data-option-ref="' + active_tab_key + '"]').addClass('smwpcb_tab_active_container');
        });

        $('#smwpcb_chatbots_weather_api').on('click',function(e) {
            $(this).prop('checked', false);
            e.preventDefault();
            alert('This option is having technical errors, it will be fixed on the next update.');

        });

        $('#smwpcb_not_good_enough_rate').on('click',function() {
            var data = {
                'action': 'smwpcb_rate_the_plugin_action',
                'rate': 'notgood'
            };
            jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data);
            $(this).closest('.notice').fadeOut('slow');

        });

        $('#smwpcb_good_rate').on('click',function() {
            var data = {
                'action': 'smwpcb_rate_the_plugin_action',
                'rate': 'good'
            };
            jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data);
            $(this).closest('.notice').fadeOut('slow');

        });

        $('#smwpcb_remind_me_later').on('click',function() {
            var data = {
                'action': 'smwpcb_rate_the_plugin_action',
                'rate': 'remindme'
            };
            jQuery.post(smwpcb_custom_ui_wp_link.ajax_url, data);
            $(this).closest('.notice').fadeOut('slow')

        });



    });

});