<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Adding, editing and deleting chatbot's agent profile page option.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_chatbot_agents')){

    function smwpcb_wp_chatbot_agents() {

      $smwpcb_wp_chatbot_agents_settings = get_option('smwpcb_wp_chatbot_agents_settings');
      if (isset($_POST['page_chatbot_agents_settings']) && check_admin_referer(plugin_basename(__FILE__), 'chatbot_agents_admin_referer')) {
        $agentArr = array();
        $agentArr['chatbots_name'] = isset($_POST['smwpcb_chatbots_name']) ? sanitize_text_field($_POST['smwpcb_chatbots_name']) : '';

        $agentArr['chatbots_avatar_attachment_id'] = isset($_POST['smwpcb_avatar_attachment_id']) ? sanitize_text_field(absint( $_POST['smwpcb_avatar_attachment_id'])) : 0;

        $agentArr['chatbots_avatar_attachment_image_url'] = (isset($_POST['smwpcb_avatar_attachment_id']) && $_POST['smwpcb_avatar_attachment_id'] != '0') ? wp_get_attachment_url( absint( sanitize_text_field($_POST['smwpcb_avatar_attachment_id'] ) ) ) : SMWPCB_PLUGIN_URL_DIR.'admin/images/blank-profile.png';

        $agentArr['chatbots_occupation'] = isset($_POST['smwpcb_chatbots_occupation']) ? sanitize_text_field($_POST['smwpcb_chatbots_occupation']) : '';

        $agentArr['chatbots_description'] = isset($_POST['smwpcb_chatbots_description']) ? sanitize_text_field($_POST['smwpcb_chatbots_description']) : '';

        array_push($smwpcb_wp_chatbot_agents_settings, $agentArr);

        update_option( 'smwpcb_wp_chatbot_agents_settings', $smwpcb_wp_chatbot_agents_settings );
        }
        if (isset($_POST['edit_page_chatbot_agents_settings']) && isset($_POST['smwpcb_edit_key'])) {
        $idkey = sanitize_text_field($_POST['smwpcb_edit_key']);

        $smwpcb_wp_chatbot_agents_settings[$idkey]['chatbots_name'] = isset($_POST['smwpcb_chatbots_name']) ? sanitize_text_field($_POST['smwpcb_chatbots_name']) : '';

        $smwpcb_wp_chatbot_agents_settings[$idkey]['chatbots_avatar_attachment_id'] = isset($_POST['smwpcb_avatar_attachment_id']) ? absint( sanitize_text_field($_POST['smwpcb_avatar_attachment_id']) ) : 0;

        $smwpcb_wp_chatbot_agents_settings[$idkey]['chatbots_avatar_attachment_image_url'] = isset($_POST['smwpcb_avatar_attachment_id']) ?  wp_get_attachment_url( absint( sanitize_text_field($_POST['smwpcb_avatar_attachment_id']) ) ): SMWPCB_PLUGIN_URL_DIR.'admin/images/blank-profile.png';

        $smwpcb_wp_chatbot_agents_settings[$idkey]['chatbots_occupation'] = isset($_POST['smwpcb_chatbots_occupation']) ? sanitize_text_field($_POST['smwpcb_chatbots_occupation']) : '';

        $smwpcb_wp_chatbot_agents_settings[$idkey]['chatbots_description'] = isset($_POST['smwpcb_chatbots_description']) ? sanitize_text_field($_POST['smwpcb_chatbots_description']) : '';

        update_option( 'smwpcb_wp_chatbot_agents_settings', $smwpcb_wp_chatbot_agents_settings );
        }
      ?>
      <div class="wrap" id="wrapAgent">
      <h1 class="wp-heading-inline"><?php esc_html_e('Agents', 'smart-wordpress-chatbot'); ?></h1>
      <?php echo((smwpcb_rate_the_plugin() != '') ? smwpcb_rate_the_plugin() : ''); ?>
      <button type="button" id="add_new_agent" class="page-title-action"><?php esc_html_e('Add New', 'smart-wordpress-chatbot'); ?></button>
      <div id="addmoreagent" class="addmoreprAg">
      <form action="" method="post">
      <table class="form-table">
      <tbody>
          <tr>
              <th scope="row"><label for="smwpcb_chatbots_name"><?php esc_html_e('Bot\'s name', 'smart-wordpress-chatbot'); ?></label></th>
              <td>
                  <input type="text" id="smwpcb_chatbots_name" name="smwpcb_chatbots_name"  placeholder="<?php esc_html_e('Bot\'s name', 'smart-wordpress-chatbot'); ?>" required/>
                  <p class="description"><?php esc_html_e('Choose the name of the Bot, that will be displayed on the chat screen', 'smart-wordpress-chatbot'); ?></p>
              </td>
          </tr>
          <tr>
              <th scope="row"><label for="smwpcb_avatar_attachment_id"><?php esc_html_e('Bot\'s Avatar ', 'smart-wordpress-chatbot'); ?></label></th>
              <td>
                  <?= smwpcb_get_attachment_select( 'smwpcb_avatar_attachment_id', 'smwpcb_avatar_attachment_id') ?>
                  <p class="description"><?php esc_html_e('Choose the avatar image for the agent bot, the prefered image size is to use one with the same width as height.', 'smart-wordpress-chatbot'); ?></p>
              </td>
          </tr>
          <tr>
              <th scope="row"><label for="smwpcb_chatbots_occupation"><?php esc_html_e('Bot\'s occupation', 'smart-wordpress-chatbot'); ?></label></th>
              <td>
                  <input type="text" id="smwpcb_chatbots_occupation" name="smwpcb_chatbots_occupation"  placeholder="<?php esc_html_e('bot\'s occupation', 'smart-wordpress-chatbot'); ?>" required/>
                  <p class="description"><?php esc_html_e('Define the bot\'s occupation, for example \'\'Personal Insurance Assistant\'\'', 'smart-wordpress-chatbot'); ?></p>
              </td>
          </tr>
          <tr>
              <th scope="row"><label for="smwpcb_chatbots_description"><?php esc_html_e('Description', 'smart-wordpress-chatbot'); ?></label></th>
              <td>
                  <textarea id="smwpcb_chatbots_description" name="smwpcb_chatbots_description" rows="4" cols="25"  placeholder="<?php esc_html_e('description of the agent', 'smart-wordpress-chatbot'); ?>" required></textarea>
                  <p class="description"><?php esc_html_e('Describe the function of this agent with first person.', 'smart-wordpress-chatbot'); ?></p>
              </td>
          </tr>
      </tbody>
      </table>
      <p class="submit">
          <input type="submit" class="button-primary" id="addAgentsubmit" value="<?php esc_html_e('Add Agent', 'smart-wordpress-chatbot') ?>" />
          <button type="button" class="button cancelsubmit" id="cancelagentsubmit"><?php esc_html_e('Cancel', 'smart-wordpress-chatbot') ?></button>
          <input type="hidden" name="page_chatbot_agents_settings" value="submit" />
          <?php wp_nonce_field(plugin_basename(__FILE__), 'chatbot_agents_admin_referer'); ?>
      </p>
      </form>
      </div>
      <div id="thelistAgent" class="agentslist">
      <?php
      if($smwpcb_wp_chatbot_agents_settings != array()){
        $width = '';
        if(count($smwpcb_wp_chatbot_agents_settings)==1) 
          $width = "30px";
        elseif(count($smwpcb_wp_chatbot_agents_settings)==2) 
          $width = "60px";
        else 
          $width = "90px";
        echo('<p id="noagent">');
        esc_html_e('Here are the available agents on your system:', 'smart-wordpress-chatbot'); 
        echo('</p><table class="smwpcb_table_agents" cellspacing="16" cellpadding="0" width="'.$width.'">
            <tbody>');
      $counttr=0;
      foreach($smwpcb_wp_chatbot_agents_settings as $k => $chatbot_agent){
        if($chatbot_agent['chatbots_avatar_attachment_id'] != 0)
        $url_attachment = wp_get_attachment_url( esc_html($chatbot_agent['chatbots_avatar_attachment_id']) );
        else
        $url_attachment = SMWPCB_PLUGIN_URL_DIR.'admin/images/blank-profile.png';

        if((($counttr) >= 3 && ($counttr)%3 == 0 ) || $counttr == 0) echo('<tr>');
        ?>
          <td class="smwpcb_the_available_agents">
              <div class="smwpcb_the_available_agents_inside">
                  <img class="smwpcb_the_available_agents_image" src="<?= $url_attachment ?>">
                  <input type="hidden" class="smwpcb_the_available_agents_image_id" value="<?= esc_html($chatbot_agent['chatbots_avatar_attachment_id']) ?>">
                  <h3 class="smwpcb_chatbot_nm"><?= stripslashes(esc_html($chatbot_agent['chatbots_name']))?></h3>
                  <span class="action-links">
                    <a class="button updatecbAgent" idkey="<?= esc_attr($k) ?>" href="#wrapAgent" role="button"><?php esc_html_e('Update', 'smart-wordpress-chatbot'); ?></a>
                    <a class="button deletecbAgent" idkey="<?= esc_attr($k) ?>" href="#thelistAgent" role="button"><?php esc_html_e('Delete', 'smart-wordpress-chatbot'); ?></a>
                </span>
                  <p class="smwpcb_agent_description">
                  <strong><?php esc_html_e('Occupation:', 'smart-wordpress-chatbot'); ?></strong><span class="smwpcb_chatbot_occup"><?= stripslashes(esc_html($chatbot_agent['chatbots_occupation'])) ?></span>. <br>
                  <strong><?php esc_html_e('Description:', 'smart-wordpress-chatbot'); ?></strong><span class="smwpcb_chatbot_desc"><?= stripslashes(esc_html($chatbot_agent['chatbots_description'])) ?> </span></p>
              </div>
          </td>
        <?php
          
          if(($counttr+1) >= 3 && ($counttr+1)%3 == 0) echo('</tr>');
          $counttr++;
        }
        echo('</tbody></table>');
        }else{
          ?>
          <p id="noagent"><?php esc_html_e('Please add an agent to use on the chat screen by clicking on add new button', 'smart-wordpress-chatbot'); ?></p>
        <?php
        }
        ?>

      </div>
      <?php

    }

}

/**
 * Output all the image on the media library in which to choose from.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_get_attachment_select')){

    function smwpcb_get_attachment_select( $input_name, $input_id ) {

      // get WP pages
      $args = array(
          'post_type' => 'attachment',
          'sort_order' => 'asc',
          'sort_column' => 'post_title',
          'post_mime_type' => 'image',
          'numberposts' => -1,
          'post_status' => 'any'
          );

      $attachments = get_posts($args);
      $select = '<select name="'. $input_name .'" ';
      if( strlen($input_id) ){
          $select .= 'id="'. $input_id .'" ';
      }
      $select .= 'required><option value="">- Select Image -</option>';
      foreach ( $attachments as $attachment ){
          $option = '<option value="' . $attachment->ID . '" >';
          $option .= $attachment->post_title;
          $option .= '</option>';
          $select .= $option;
      }
      $select .= '</select>';
      return $select;

    }

}



?>