<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Adding, editing and deleting data columns page option.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_chatbot_data_tables')){

    function smwpcb_wp_chatbot_data_tables() {

      $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
      
        if (isset($_POST['page_chatbots_data_tables']) && check_admin_referer(plugin_basename(__FILE__), 'data_tables_admin_referer')) {
          $wp_chatbot = array();
          $wp_chatbot['name'] = (isset($_POST['smwpcb_column_table_name'])) ? $_POST['smwpcb_column_table_name'] : '';
          $wp_chatbot['variable'] = (isset($_POST['smwpcb_column_table_variable'])) ? $_POST['smwpcb_column_table_variable'] : '';
          if(isset($_POST['smwpcb_column_table_validation'])){
            $tablevalidation = '';
            $tablevalidation .= (isset($_POST['smwpcb_is_email'])) ? sanitize_text_field($_POST['smwpcb_is_email']) : '';
            $tablevalidation .= (isset($_POST['smwpcb_is_phone'])) ? ','.sanitize_text_field($_POST['smwpcb_is_phone']) : '';
            $tablevalidation .= (isset($_POST['smwpcb_is_digit'])) ? ','.sanitize_text_field($_POST['smwpcb_is_digit']) : '';
            $tablevalidation .= (isset($_POST['smwpcb_is_alph'])) ? ','.sanitize_text_field($_POST['smwpcb_is_alph']) : '';
            $tablevalidation .= (isset($_POST['smwpcb_is_alphanum'])) ? ','.sanitize_text_field($_POST['smwpcb_is_alphanum']) : '';

            $wp_chatbot['column_validation'] = $tablevalidation;
            $tablevalidationmsg = '';
            $tablevalidationmsg .= (isset($_POST['smwpcb_is_email'])) ? sanitize_text_field($_POST['smwpcb_is_email_msg']) : '';
            $tablevalidationmsg .= (isset($_POST['smwpcb_is_phone'])) ? ','.sanitize_text_field($_POST['smwpcb_is_phone_msg']) : '';
            $tablevalidationmsg .= (isset($_POST['smwpcb_is_digit'])) ? '|6^9~'.sanitize_text_field($_POST['smwpcb_is_digit_msg']) : '';
            $tablevalidationmsg .= (isset($_POST['smwpcb_is_alph'])) ? '|6^9~'.sanitize_text_field($_POST['smwpcb_is_alph_msg']) : '';
            $tablevalidationmsg .= (isset($_POST['smwpcb_is_alphanum'])) ? '|6^9~'.sanitize_text_field($_POST['smwpcb_is_alphanum_msg']) : '';
            $wp_chatbot['column_validation_msg'] = $tablevalidationmsg;
          }else{
            $wp_chatbot['column_validation'] = '';
            $wp_chatbot['column_validation_msg'] = '';
          }
          $wp_chatbot['column_last_modified'] = date('m/d/Y h:i a');
          array_push($smwpcb_data_tables_settings, $wp_chatbot);
          update_option( 'smwpcb_data_tables_settings', $smwpcb_data_tables_settings );
        }
      
      if(isset($_POST['edit_page_chatbots_data_tables']) && isset($_POST['smwpcb_edit_column_key'])){
        $smwpcb_data_tables_settings[$_POST['smwpcb_edit_column_key']]['name'] = (isset($_POST['smwpcb_column_table_name'])) ? sanitize_text_field($_POST['smwpcb_column_table_name']) : '';
        $smwpcb_data_tables_settings[$_POST['smwpcb_edit_column_key']]['variable'] = (isset($_POST['smwpcb_column_table_variable'])) ? sanitize_text_field($_POST['smwpcb_column_table_variable']) : '';
        if(isset($_POST['smwpcb_column_table_validation'])){
          $tablevalidation = '';
          $tablevalidation .= (isset($_POST['smwpcb_is_email'])) ? sanitize_text_field($_POST['smwpcb_is_email']) : '';
          $tablevalidation .= (isset($_POST['smwpcb_is_phone'])) ? ','.sanitize_text_field($_POST['smwpcb_is_phone']) : '';
          $tablevalidation .= (isset($_POST['smwpcb_is_digit'])) ? ','.sanitize_text_field($_POST['smwpcb_is_digit']) : '';
          $tablevalidation .= (isset($_POST['smwpcb_is_alph'])) ? ','.sanitize_text_field($_POST['smwpcb_is_alph']) : '';
          $tablevalidation .= (isset($_POST['smwpcb_is_alphanum'])) ? ','.sanitize_text_field($_POST['smwpcb_is_alphanum']) : '';
          $smwpcb_data_tables_settings[$_POST['smwpcb_edit_column_key']]['column_validation'] = $tablevalidation;
          $tablevalidationmsg = '';
          $tablevalidationmsg .= (isset($_POST['smwpcb_is_email'])) ? sanitize_text_field($_POST['smwpcb_is_email_msg']) : '';
          $tablevalidationmsg .= (isset($_POST['smwpcb_is_phone'])) ? '|6^9~'.sanitize_text_field($_POST['smwpcb_is_phone_msg']) : '';
          $tablevalidationmsg .= (isset($_POST['smwpcb_is_digit'])) ? '|6^9~'.sanitize_text_field($_POST['smwpcb_is_digit_msg']) : '';
          $tablevalidationmsg .= (isset($_POST['smwpcb_is_alph'])) ? '|6^9~'.sanitize_text_field($_POST['smwpcb_is_alph_msg']) : '';
          $tablevalidationmsg .= (isset($_POST['smwpcb_is_alphanum'])) ? '|6^9~'.sanitize_text_field($_POST['smwpcb_is_alphanum_msg']) : '';
          $smwpcb_data_tables_settings[$_POST['smwpcb_edit_column_key']]['column_validation_msg'] = $tablevalidationmsg;
          }else{
            $smwpcb_data_tables_settings[$_POST['smwpcb_edit_column_key']]['column_validation'] = '';
            $smwpcb_data_tables_settings[$_POST['smwpcb_edit_column_key']]['column_validation_msg'] = '';
          }
          $smwpcb_data_tables_settings[$_POST['smwpcb_edit_column_key']]['column_last_modified'] = date('m/d/Y h:i a');
        update_option( 'smwpcb_data_tables_settings', $smwpcb_data_tables_settings );
      }
      ?>
      <div class="wrap">
      <h1 class="wp-heading-inline"><?php esc_html_e('Data Columns', 'smart-wordpress-chatbot'); ?></h1>
      <?php echo((smwpcb_rate_the_plugin() != '') ? smwpcb_rate_the_plugin() : ''); 
      
      
        ?>
        <button type="button" id="add_new_agent" class="page-title-action"><?php esc_html_e('Add New', 'smart-wordpress-chatbot'); ?></button>
        <?php
      
      ?>
      <div id="addmoreproject" class="addmoreprAg">
      <form action="" method="post">
      <table class="form-table">
      <tbody>
        <tr>
            <th scope="row"><label for="smwpcb_column_table_name"><?php esc_html_e('Data Column Name', 'smart-wordpress-chatbot'); ?></label></th>
            <td>
                <input type="text" id="smwpcb_column_table_name" name="smwpcb_column_table_name"/>
                <p class="description"><?php esc_html_e('Please enter the name of the data colum.', 'smart-wordpress-chatbot'); ?></p>
            </td>
          </tr>
          <tr>
              <th scope="row"><label for="smwpcb_column_table_variable"><?php esc_html_e('Variable Name', 'smart-wordpress-chatbot'); ?></label></th>
              <td>
                  <input type="text" id="smwpcb_column_table_variable" name="smwpcb_column_table_variable"/>
                  <p class="description"><?php esc_html_e('This variable name can be used on message bubbles, @&lt;your-variable&gt; can identify the users entries.', 'smart-wordpress-chatbot'); ?></p>
              </td>
          </tr>
          <tr>
              <th scope="row"><label for="smwpcb_column_table_validation"><?php esc_html_e('Column Validation', 'smart-wordpress-chatbot'); ?></label></th>
              <td>
                <?php smwpcb_get_all_the_validations() ?>
                  <p class="description"><?php esc_html_e('Choose how you want to validate users entries.', 'smart-wordpress-chatbot'); ?></p>
              </td>
          </tr>
      </tbody>
      </table>
      <p class="submit">
          <input type="submit" class="button-primary" id="addcolumnsubmit" value="<?php esc_html_e('Add Column', 'smart-wordpress-chatbot') ?>" />
          <button type="button" class="button cancelsubmit" id="cancelagentsubmit"><?php esc_html_e('Cancel', 'smart-wordpress-chatbot') ?></button>
          <input type="hidden" name="page_chatbots_data_tables" value="submit" />
          <?php wp_nonce_field(plugin_basename(__FILE__), 'data_tables_admin_referer'); ?>
      </p>
      </form>
      </div>
      <div class="tablenav top">
        <div class="alignleft actions bulkactions">
            <label for="bulk-action-selector-top" class="screen-reader-text"><?php esc_html_e('Select bulk action', 'smart-wordpress-chatbot'); ?></label>
            <select name="action" id="bulk-action-selector-top">
                <option value=""><?php esc_html_e('Bulk Actions', 'smart-wordpress-chatbot'); ?></option>
                <option value="delete-selected-column-table"><?php esc_html_e('Delete', 'smart-wordpress-chatbot'); ?></option>
            </select>
            <input type="submit" class="button" id="applyColumnTable" value="<?php esc_html_e('Apply', 'smart-wordpress-chatbot'); ?>">
        </div>
      </div>
        <table class="smwpcb_table_fix widefat striped smwpcb_users_data">
          <thead>
              <tr>
                  <td id="cb" class="manage-column column-cb check-column smwpcb_column_fix">
                      <label class="screen-reader-text" for="cb-select-all-1"><?php esc_html_e('Select All', 'smart-wordpress-chatbot'); ?></label>
                      <input id="cb-select-all-1" type="checkbox" value="">
                  </td>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Data Column', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span></a></th>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Variable', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Validation', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Message', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
                  <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Last Modified', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a>
                  </th>
              </tr>
          </thead>
          <tbody id="the-list">
              <?php
              if(count($smwpcb_data_tables_settings) == 0){
                echo('<tr><td class="row-title" colspan="6">');
                esc_html_e('There\'s no Column Data', 'smart-wordpress-chatbot');
                echo('</td></tr>');
              }else{
                foreach ($smwpcb_data_tables_settings as $key => $table_settings) {
                  ?>
                  <tr>
                  <th scope="row" class="check-column smwpcb_column_fix">
                      <input type="checkbox" class="checkedColumnTable" value="<?= $key ?>">
                  </th>
                  <td class="column-primary">
                    <strong><a href="javascript:void(0)" key="<?= $key ?>" class="updatecbcolumn"><?= esc_html(stripslashes($table_settings['name'])) ?></a></strong>
                      <div class="row-actions">
                        <span class="edit">
                          <a href="javascript:void(0)" key="<?= $key ?>" class="updatecbcolumn"><?php esc_html_e('Edit', 'smart-wordpress-chatbot'); ?></a> | </span>
                        <span class="trash">
                          <a href="javascript:void(0)" key="<?= $key ?>" class="deletecbcolumn"><?php esc_html_e('Trash', 'smart-wordpress-chatbot'); ?></a> </span>
                      </div>
                  </td>
                  <td>
                  <?= stripslashes(esc_html($table_settings['variable'])) ?>
                  <td>
                    <?php
                    if(substr($table_settings['column_validation'], 0, 1) == ',')
                      $table_settings['column_validation'] = substr(esc_html($table_settings['column_validation']), 1);
                    $column_validation = '-'.stripslashes(esc_html($table_settings['column_validation']));
                    echo(str_replace(',', '<br>-', $column_validation));
                    ?>
                  </td>
                  <td>
                    <?php
                    if(substr($table_settings['column_validation_msg'], 0, 5) == '|6^9~')
                      $table_settings['column_validation_msg'] = substr(esc_html($table_settings['column_validation_msg']), 5);
                    $column_validation_msg = '-'.stripslashes(esc_html($table_settings['column_validation_msg']));
                    echo(str_replace('|6^9~', '<br>-', $column_validation_msg));
                    ?>
                  </td>
                  <td>
                  <?= $table_settings['column_last_modified'] ?>
                  </td>
                      
                  </tr>
                  <?php
                }
              }
              ?>
          </tbody>
          <tfoot>
            <tr>
                <td id="cb" class="manage-column column-cb check-column smwpcb_column_fix">
                      <label class="screen-reader-text" for="cb-select-all-1"><?php esc_html_e('Select All', 'smart-wordpress-chatbot'); ?></label>
                      <input id="cb-select-all-1" type="checkbox" value="">
                  </td>
                <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Data Column', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span></a></th>
                <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Variable', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
                <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Validation', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
                <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Message', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
                <th scope="col" class="manage-column sortable desc"><a href="javascript:void(0)"><span><?php esc_html_e('Last Modified', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a>
                </th>
            </tr>
          </tfoot>
        </table>
      </div>
     <?php

    }

}

/**
 * Input validation options.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_get_all_the_validations')){

  function smwpcb_get_all_the_validations(){

    ?>
    <label class="smwpcb_switch_toggle">
      <input type='checkbox' value='validchecked' id='smwpcb_column_table_validation' name='smwpcb_column_table_validation'>
      <div class="smwpcb_toggle round"></div>
      <input type='hidden' id='smwpcb_column_table_validation_msg' name='smwpcb_column_table_validation_msg'>
    </label>
    <div class="smwpcb_toggle_validation">
    <div class="smwpcb_validation_unit">
    <label class="smwpcb_switch_toggle"><input type='checkbox' value='is_email' name='smwpcb_is_email' class='smwpcb_add_to_validation' > <div class="smwpcb_toggle round"></div>
    </label><?php esc_html_e(' Email', 'smart-wordpress-chatbot'); ?><br>
    <textarea class="smwpcb_add_to_validation_msg" name="smwpcb_is_email_msg" rows="4" cols="25" placeholder="<?php esc_html_e('validation message', 'smart-wordpress-chatbot'); ?>"></textarea>
    <p class="description valmsgdescription"><?php esc_html_e('Please enter a validation message for email format checking.', 'smart-wordpress-chatbot'); ?></p> 
    </div>
    <div class="smwpcb_validation_unit">
    <label class="smwpcb_switch_toggle"><input type='checkbox' value='is_phone' name='smwpcb_is_phone' class='smwpcb_add_to_validation' ><div class="smwpcb_toggle round"></div>
    </label> <?php esc_html_e(' Phone', 'smart-wordpress-chatbot'); ?> <br>
    <textarea class="smwpcb_add_to_validation_msg" name="smwpcb_is_phone_msg" rows="4" cols="25" placeholder="<?php esc_html_e('validation message', 'smart-wordpress-chatbot'); ?>"></textarea>
    <p class="description valmsgdescription"><?php esc_html_e('Please enter a validation message for phone format checking.', 'smart-wordpress-chatbot'); ?></p> 
    </div>
    <div class="smwpcb_validation_unit">
    <label class="smwpcb_switch_toggle"><input type='checkbox' value='is_digit' name='smwpcb_is_digit' class='smwpcb_add_to_validation' ><div class="smwpcb_toggle round"></div>
    </label> <?php esc_html_e(' Digit', 'smart-wordpress-chatbot'); ?>  <br>

    <textarea class="smwpcb_add_to_validation_msg" name="smwpcb_is_digit_msg" rows="4" cols="25" placeholder="<?php esc_html_e('validation message', 'smart-wordpress-chatbot'); ?>"></textarea>
        <p class="description valmsgdescription"><?php esc_html_e('Please enter a validation message for numeric format checking.', 'smart-wordpress-chatbot'); ?></p>
    </div>
    <div class="smwpcb_validation_unit">
    <label class="smwpcb_switch_toggle"><input type='checkbox' value='is_alpha' name='smwpcb_is_alph' class='smwpcb_add_to_validation' ><div class="smwpcb_toggle round"></div>
    </label><?php esc_html_e(' Alphabet', 'smart-wordpress-chatbot'); ?><br>

    <textarea class="smwpcb_add_to_validation_msg" name="smwpcb_is_alph_msg" rows="4" cols="25" placeholder="<?php esc_html_e('validation message', 'smart-wordpress-chatbot'); ?>"></textarea>
        <p class="description valmsgdescription"><?php esc_html_e('Please enter a validation message for alphabetic characters checking.', 'smart-wordpress-chatbot'); ?></p>
    </div>
    <div class="smwpcb_validation_unit">
    <label class="smwpcb_switch_toggle"><input type='checkbox' value='is_alphnum' name='smwpcb_is_alphanum' class='smwpcb_add_to_validation' ><div class="smwpcb_toggle round"></div>
    </label><?php esc_html_e(' Alphanumeric', 'smart-wordpress-chatbot'); ?><br>

    <textarea class="smwpcb_add_to_validation_msg" name="smwpcb_is_alphanum_msg" rows="4" cols="25" placeholder="<?php esc_html_e('validation message', 'smart-wordpress-chatbot'); ?>"></textarea>
    <p class="description valmsgdescription"><?php esc_html_e('Please enter a validation message for alphanumeric characters checking.', 'smart-wordpress-chatbot'); ?></p>
    </div>
    </div>
    <?php
    
  }

}


?>
