<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Customizing the widget style by changing parameters on this page options.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_design_chatbot_ui')){

   function smwpcb_wp_design_chatbot_ui() {

     $smwpcb_cb_ui_custom = get_option('smwpcb_cb_ui_custom_settings');
     ?>
     <div class="wrap">
      <h1 class="wp-heading-inline"><?php esc_html_e('Customize Widget Design', 'smart-wordpress-chatbot'); ?></h1>
      <?php echo((smwpcb_rate_the_plugin() != '') ? smwpcb_rate_the_plugin() : ''); ?>
      <div class="updated <?php if($_GET['saved']) {echo "smwpcb_message_design_cus_block";} else { echo "smwpcb_message_design_cus_none"; } ?>" >
          <p><strong><?php esc_html_e('Settings were saved successfully you can see changes on the testing or on the actual project.', 'smart-wordpress-chatbot'); ?></strong></p>
      </div>
	    <div id="poststuff">
	    <div id="post-body">
	        <div class="nav-tab-wrapper smwpcb_unset_bottom">
	            <a href="#smwpcb-ps" data-tab-name="smwpcb-ps" class="nav-tab nav-tab-active"><?php esc_html_e('Widget Icon', 'smart-wordpress-chatbot'); ?></a>
	            <a href="#smwpcb-ccnv" data-tab-name="smwpcb-ccnv" class="nav-tab"><?php esc_html_e('Chat Conversation', 'smart-wordpress-chatbot'); ?></a>
	            <a href="#smwpcb-cmod" data-tab-name="smwpcb-cmod" class="nav-tab"><?php esc_html_e('Color Modification', 'smart-wordpress-chatbot'); ?></a>
	        </div>
	        <div class="smwpcb-settings-container">
	            <div class="smwpcb-settings-grid smwpcb-settings-main-cont">
	                    <div class="smwpcb-tab-container" data-tab-name="smwpcb-ps">
	                        <div class="postbox">
	                            <div class="inside">
	                                <form autocomplete="off" id="smwpcb_settings_form" method="post" action="">
	                                <table class="form-table">
	                                    <tbody>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Width & Height', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input min="50" type="number" id="smwpcb_prime_width" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_prime_width']); ?>" />
	                                                <p class="description"><?php esc_html_e('Enter the width and the height of the icon.', 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Icon size', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" min="0" type="number" id="smwpcb_prime_icon_size" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_prime_icon_size']); ?>" />
	                                                <p class="description"><?php esc_html_e("Enter the icon size of the prime.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Icon Message', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" type="text" id="smwpcb_prime_icon_msg" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_prime_icon_msg']); ?>" />
	                                                <br>
	                                                <p class="description"><?php esc_html_e("Enter the unicode of the message icon, get the unicode from any icon on this",'smart-wordpress-chatbot');?> <a href='http://zavoloklom.github.io/material-design-iconic-font/icons.html' target="_blank">list</a><?php esc_html_e(", click on any one of them to get the unicode.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Icon Close', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" type="text" id="smwpcb_prime_icon_x" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_prime_icon_x']); ?>" />
	                                                <br>
	                                                <p class="description"><?php esc_html_e("Enter the unicode of the close icon, get the unicode from any icon on this ",'');?><a href='http://zavoloklom.github.io/material-design-iconic-font/icons.html' target="_blank">list</a><?php esc_html_e(", click on any one of them to get the unicode.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>

	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Message Sound', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <?= smwpcb_get_all_the_sounds('smwpcb_message_sound',$smwpcb_cb_ui_custom['smwpcb_message_sound']) ?>
	                                                <p class="description"><?php esc_html_e("Enter the sound of the notification message on the chat.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>



	                                    </tbody>
	                                </table>
	                                <p class="submit">
					                  <button type="button" class="button-primary cb_ui_custom_setDefault" key="1"><?php esc_html_e('Go to default', 'smart-wordpress-chatbot') ?></button>
					                  <a href="#smwpcb-ccnv" type="button" class="button-primary cancelsubmit smwpcb_next_tab" data-tab-name="smwpcb-ccnv"><?php esc_html_e('Next Options', 'smart-wordpress-chatbot') ?></a>
					                </p>
	                            </form>
	                            </div>
	                            <!-- end of inside -->
	                        </div>
	                        <!-- end of postbox -->
	                    </div>
	                    <div class="smwpcb-tab-container" data-tab-name="smwpcb-ccnv">
	                        <div class="postbox">
	                            <div class="inside">
	                                <form autocomplete="off" id="smwpcb_settings_form" method="post" action="">
	                                <table class="form-table">
	                                    <tbody>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Position from the right', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" type="number" id="smwpcb_chat_pos_right" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_pos_right']); ?>" />
	                                                <p class="description"><?php esc_html_e("Enter the Position from the right of the widget", 'smart-wordpress-chatbot'); ?></p>
	                                                <input class="small" type="number" id="smwpcb_chat_pos_right_chat" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_pos_right_chat']); ?>" />
	                                                <p class="description"><?php esc_html_e("Enter the Position from the right of the page of the chat screen.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Position from the bottom', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" min="0" type="number" id="smwpcb_chat_pos_bottom" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_pos_bottom']); ?>" />
	                                    			<p class="description"><?php esc_html_e("Enter the Position from the bottom of the page of the widget.", 'smart-wordpress-chatbot'); ?></p>
	                                    			<input class="small" min="0" type="number" id="smwpcb_chat_pos_bottom_chat" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_pos_bottom_chat']); ?>" />
	                                    			<p class="description"><?php esc_html_e("Enter the Position from the bottom of the page of the chat screen.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Font size', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" min="0" type="number" id="smwpcb_chat_font_size" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_font_size']); ?>" /> 
                                    			<p class="description"><?php esc_html_e("Enter the font size of text displayed in messages.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Line height', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" min="0" type="number" id="smwpcb_chat_line_height" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_line_height']); ?>" />
	                                    			<p class="description"><?php esc_html_e("Enter the line height of the paragraph displayed in messages.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Font weight', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" min="0" type="number" step="100" id="smwpcb_chat_font_weight" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_font_weight']); ?>" /><br />
                                    				<p class="description"><?php esc_html_e("Enter the font weight of text displayed in messages.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        
	                                    </tbody>
	                                </table>
	                                <p class="submit">
						                <button class="button-primary cb_ui_custom_setDefault" key="2"><?php esc_html_e('Go to default', 'smart-wordpress-chatbot') ?></button>
						                <a href="#smwpcb-cmod" type="button" class="button-primary cancelsubmit smwpcb_next_tab" data-tab-name="smwpcb-cmod"><?php esc_html_e('Next Options', 'smart-wordpress-chatbot') ?></a>
						            </p>
	                            </form>
                            </div>
                            <!-- end of inside -->
                        </div>
                        <!-- end of postbox -->
                    </div>
	                <div class="smwpcb-tab-container" data-tab-name="smwpcb-cmod">
	                        <div class="postbox">
	                            <div class="inside">
	                                <form autocomplete="off" id="smwpcb_settings_form" method="post" action="">
	                                <table class="form-table">
	                                    <tbody>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Icon Background color', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" type="color" id="smwpcb_prime_background" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_prime_background']); ?>" />
			                                    	<p class="description"><?php esc_html_e("Enter the background color of the prime, chat header.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Icon color', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" type="color" id="smwpcb_prime_font_color" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_prime_font_color']); ?>" />
			                                    	<p class="description"><?php esc_html_e("Enter the color of the widget.", 'smart-wordpress-chatbot'); ?></p>
			                                    	<input class="small" type="color" id="smwpcb_prime_font_color_hover" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_prime_font_color_hover']); ?>" />
			                                    	<p class="description"><?php esc_html_e("Enter the color of the widget on hover.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Background color', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input type="color" id="smwpcb_chat_conversation_bg" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_conversation_bg']); ?>" /> <br />
                                    				<p class="description"><?php esc_html_e("Enter the background color of the chat conversation, it is recommended to use the same one as the text color of text in header.", 'smart-wordpress-chatbot'); ?></p>
                                    				<input type="color" id="smwpcb_chat_conversation_bg_bot" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_conversation_bg_bot']); ?>" /> 
                                    				<p class="description"><?php esc_html_e("Enter the background color of the messages sent from the agent bot.", 'smart-wordpress-chatbot'); ?></p>
                                    				<input type="color" id="smwpcb_chat_conversation_bg_user" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_conversation_bg_user']); ?>" />
                                    				<p class="description"><?php esc_html_e("Enter the background color of the messages sent from the user, it is recommended to use the same one as the color of the background of the chat header.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Text color', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input type="color" id="smwpcb_chat_conversation_color" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_conversation_color']); ?>" /> 
                                    				<p class="description"><?php esc_html_e("Enter the color of the desciption of the bot.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                        <tr valign="top">
	                                            <th scope="row"><?php esc_html_e('Font weight', 'smart-wordpress-chatbot'); ?></th>
	                                            <td>
	                                                <input class="small" min="0" type="number" step="100" id="smwpcb_chat_font_weight" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_font_weight']); ?>" /><br />
                                    				<p class="description"><?php esc_html_e("Enter the font weight of text displayed in messages.", 'smart-wordpress-chatbot'); ?></p>
                                    				<input type="color" id="smwpcb_chat_conversation_color_bot" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_conversation_color_bot']); ?>" /> <br />
                                					<p class="description"><?php esc_html_e("Enter the text color of the messages sent from the agent bot.", 'smart-wordpress-chatbot'); ?></p>
                                					<input type="color" id="smwpcb_chat_conversation_color_user" value="<?php echo esc_html($smwpcb_cb_ui_custom['smwpcb_chat_conversation_color_user']); ?>" />
                                    				<p class="description"><?php esc_html_e("Enter the text color of the messages sent from the user, it is recommended to use the same one as the color of the text of the chat header.", 'smart-wordpress-chatbot'); ?></p>
	                                            </td>
	                                        </tr>
	                                    </tbody>
	                                </table>
	                                <p class="submit">
						                <button class="button-primary cb_ui_custom_setDefault" key="3"><?php esc_html_e('Go to default', 'smart-wordpress-chatbot') ?></button>
						                <button class="button-primary cancelsubmit" id="smwpcb_cb_ui_custom"><?php esc_html_e('Save changes', 'smart-wordpress-chatbot') ?>
						                </button>
		            				</p>
	                            </form>
                            </div>
                            <!-- end of inside -->
                        </div>
                        <!-- end of postbox -->
                    </div>
	            	</div>
			       </div>
			     </div>
			 	 </div>
			 </div>

      <?php

    }

}

/**
 * Helper function to generate darker or ligther color.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_adjust_brightness_color')){

	function smwpcb_adjust_brightness_color($hex, $steps){
	  	// Steps should be between -255 and 255. Negative = darker, positive = lighter
	    $steps = max(-255, min(255, $steps));

	    // Normalize into a six character long hex string
	    $hex = str_replace('#', '', $hex);
	    if (strlen($hex) == 3) {
	        $hex = str_repeat(substr($hex,0,1), 2).str_repeat(substr($hex,1,1), 2).str_repeat(substr($hex,2,1), 2);
	    }

	    // Split into three parts: R, G and B
	    $color_parts = str_split($hex, 2);
	    $return = '#';

	    foreach ($color_parts as $color) {
	        $color   = hexdec($color); // Convert to decimal
	        $color   = max(0,min(255,$color + $steps)); // Adjust color
	        $return .= str_pad(dechex($color), 2, '0', STR_PAD_LEFT); // Make two char hex code
	    }

	    return $return;
	}

}

/**
 * Generate the css file according to the settings options.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_modify_ui_cb_style_file')){

  function smwpcb_modify_ui_cb_style_file($optionsArr){

    file_put_contents(SMWPCB_PLUGIN_DIR . "public/css/widget-style.css", "");
    $myfile = fopen(SMWPCB_PLUGIN_DIR . "public/css/widget-style.css", "w") or wp_die("Unable to open file!");
    $str = "	
	  	@import url('//fonts.googleapis.com/css?family=Open+Sans:300,300i,400,400i,600,600i,700,700i,800,800i&subset=cyrillic,cyrillic-ext');
		@import url('./zmdiCss.css');
		@import url('//fonts.googleapis.com/css?family=Roboto:400,500,700,900,300');
		.smwpcb_widget_chat *, .smwpcb_widget_chat *:before, .smwpcb_widget_chat *:after {
			-webkit-box-sizing: border-box;
			-moz-box-sizing: border-box;
	 		box-sizing: border-box;
		}
		.smwpcb_widget_chat{
		  z-index: 99999999999999999;
		  position: relative;
		}
		.smwpcb_widget_chat ul li{
		  list-style: none !important;
		}
		.smwpcb_widget_chat .smwpcb_widget_chatbot {
		  bottom: ".$optionsArr['smwpcb_chat_pos_right']."px;
		  position: fixed;
		  margin: 0;
		  right: ".$optionsArr['smwpcb_chat_pos_bottom']."px;
		  z-index: 998;
		  
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers {
		  display: block;
		  width: ".$optionsArr['smwpcb_prime_width']."px;
		  height: ".$optionsArr['smwpcb_prime_width']."px;
		  border-radius: 50%;
		  text-align: center;
		  color: ".$optionsArr['smwpcb_prime_font_color'].";
		  margin: 25px auto 0;
		  box-shadow: 0 0 4px rgba(0, 0, 0, .14), 0 4px 8px rgba(0, 0, 0, .28);
		  cursor: pointer;
		  -webkit-transition: all .1s ease-out;
		  transition: all .1s ease-out;
		  position: relative;
		  z-index: 998;
		  overflow: hidden;
		  background: ".$optionsArr['smwpcb_prime_background'].";
		  box-shadow: none !important;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers > i {
		  font-size: ".$optionsArr['smwpcb_prime_icon_size']."px;
		  line-height: ".$optionsArr['smwpcb_prime_width']."px;
		  -webkit-transition: all .2s ease-out;
		  -webkit-transition: all .2s ease-in-out;
		  transition: all .2s ease-in-out;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:not(:last-child) {
		  width: 0;
		  height: 0;
		  margin: 20px auto 0;
		  opacity: 0;
		  display:none;
		  line-height: 40px;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:not(:last-child) > i {
		  font-size: 1.4em;
		  line-height: 40px;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:not(:last-child).smwpcb_is_visible {
		  width: 40px;
		  height: 40px;
		  margin: 15px auto 10;
		  opacity: 1;
		  display:block;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:nth-last-child(1) {
		  -webkit-transition-delay: 25ms;
		  transition-delay: 25ms;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:not(:last-child):nth-last-child(2) {
		  -webkit-transition-delay: 20ms;
		  transition-delay: 20ms;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:not(:last-child):nth-last-child(3) {
		  -webkit-transition-delay: 40ms;
		  transition-delay: 40ms;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:not(:last-child):nth-last-child(4) {
		  -webkit-transition-delay: 60ms;
		  transition-delay: 60ms;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:not(:last-child):nth-last-child(5) {
		  -webkit-transition-delay: 80ms;
		  transition-delay: 80ms;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers(:last-child):active,
		.smwpcb_widget_chat .smwpcb_widget_chat_convers(:last-child):focus,
		.smwpcb_widget_chat .smwpcb_widget_chat_convers(:last-child):hover {
		  box-shadow: 0 0 6px rgba(0, 0, 0, .16), 0 6px 12px rgba(0, 0, 0, .32);
		}
		.smwpcb_widget_chat .smwpcb_chat_layout {
		  position: fixed;
		  right: ".$optionsArr['smwpcb_chat_pos_right_chat']."px;
		  bottom: ".$optionsArr['smwpcb_chat_pos_bottom_chat']."px;
		  width: 400px;
		  line-height: ".$optionsArr['smwpcb_chat_line_height']."px;
		  font-size: ".$optionsArr['smwpcb_chat_font_size']."px;
		  font-family: 'Open Sans', sans-serif;
		  font-weight: ".$optionsArr['smwpcb_chat_font_weight'].";
		  -webkit-font-smoothing: antialiased;
		  font-smoothing: antialiased;
		  opacity: 0;
		  box-shadow: 1px 1px 100px 2px rgba(0, 0, 0, 0.22);
		  border-radius: 10px;
		  -webkit-transition: all .2s ease-out;
		  -webkit-transition: all .2s ease-in-out;
		  transition: all .2s ease-in-out;
		}
		.smwpcb_widget_chat .smwpcb_chat_layout_screen {
	    position: fixed;
	    right: 0px;
	    bottom: 0px;
	    top: 0px;
		}
		.smwpcb_widget_chat .smwpcb_back{
			font-size: 50px;
			float: left;
			margin: 0px 25px 12px 14px;
			cursor:pointer;
		}
		.smwpcb_widget_chat .smwpcb_header_chat {
	    font-size: 13px;
	    font-family: 'Open Sans', sans-serif;
	    font-weight: 500;
	    color: ".$optionsArr['smwpcb_prime_font_color'].";
	    height: 70px;
	    background: ".$optionsArr['smwpcb_prime_background'].";
	    border-top-left-radius: 10px;
	    border-top-right-radius: 10px;
	    padding-top: 8px;
		}
		.smwpcb_widget_chat .smwpcb_header_chat_alt {
	    border-top-left-radius: 0px;
	    border-top-right-radius: 0px;
		}
		.smwpcb_widget_chat .smwpcb_online_icon {
	    display: none;
	    float: right;
	    cursor: pointer;
	    font-size: 20px;
	    opacity: 0.5;
	    margin: -10px 10px;
		}
		.smwpcb_widget_chat .smwpcb_online_icon i {
    	color: #4de313;
    	font-size: 15px;
    	margin-right: 10px;
		}
		.smwpcb_widget_chat .smwpcb_present_agent {
		margin-top:6px
		}
		.smwpcb_widget_chat .smwpcb_fs_change {
		font-size: 13px !important;
		}
		.smwpcb_widget_chat .smwpcb_fist_quote{
		margin-right: 5px;
		-ms-transform: rotate(180deg);
		-webkit-transform: rotate(180deg);
		transform: rotate(180deg);
		}
		.smwpcb_widget_chat .smwpcb_last_quote{
		margin-left: 5px;
		}
		.smwpcb_widget_chat .smwpcb_chat_layout.smwpcb_is_visible {
		  opacity: 1;
		  -webkit-animation: zoomIn .2s cubic-bezier(.42, 0, .58, 1);
		  animation: zoomIn .2s cubic-bezier(.42, 0, .58, 1);
		}
		.smwpcb_widget_chat .smwpcb_is_hide{
		  opacity: 0
		}
		.smwpcb_widget_chat .smwpcb_chat_info {
		  float: left;
		  font-size: 15px;
		  list-style: none;
		  position: relative;
		  height: 100%;
		  width: 100%;
		  text-align: relative;
		  margin-right: 10px;
      letter-spacing: 0.5px;
      font-weight: 400
		}
		.smwpcb_widget_chat .smwpcb_chat_info img {
	    border-radius: 50%;
	    width: 62px;
	    height: 62px;
	    float: left;
	    margin: -5px 17px 10px 10px;
	    border: 4px solid ".smwpcb_adjust_brightness_color($optionsArr['smwpcb_prime_background'],-60).";
		}
		.smwpcb_widget_chat .smwpcb_chat_info .smwpcb_agent_occupation {
	    font-size: 14px;
	    font-weight: 500;
		}
		.smwpcb_widget_chat iframe {
		  width:100%;
		}
		.smwpcb_widget_chat .smwpcb_chat_input {
		  position: relative;
		  margin: 5px 0 5px 0;
		  width: 50%;
		  font-family: 'Open Sans', sans-serif;
		  color: ".smwpcb_adjust_brightness_color($optionsArr['smwpcb_chat_conversation_bg'],-150).";
		  -webkit-font-smoothing: antialiased;
		  font-smoothing: antialiased;
		  border: none;
		  outline: none;
		  display: inline-block;
		  line-height: 17px;
		  height: 32px;
		  resize: none;
		  font-size: 14px;
		  font-weight: 400;
		  padding-top: 8px;
		  padding-bottom: 6px;
		}
		.smwpcb_widget_chat .smwpcb_quick_replies{
	    bottom: 0px !important;
	    display: block !important;
	    width: 90% !important;
	    max-height: 150px !important;
	    overflow: auto !important;
	    padding: 0px !important;
		}
		.smwpcb_widget_chat .smwpcb_chat_input_field {
		  width: 100%;
		  display: inline-block;
		  text-align: center;
		  background: #fff;
		  border-top: 1px solid ".smwpcb_adjust_brightness_color($optionsArr['smwpcb_chat_conversation_bg'],4).";
		  border-bottom-right-radius: 10px;
		  border-bottom-left-radius: 10px;
		}
		.smwpcb_widget_chat .smwpcb_chat_input_field_alt {
	    bottom: 0px;
	    position: absolute;
	    border-bottom-right-radius: 0px;
	    border-bottom-left-radius: 0px;
	        z-index: 999;
	  }
		.smwpcb_widget_chat .smwpcb_chat_input_field a {
		  display: inline-block;
		  text-align: center;
		}
		.smwpcb_widget_chat .smwpcb_image_chat {
			max-width: 100%;
		}
		.smwpcb_widget_chat #smwpcb_input_send {
		  float: right;
		  background: transparent !important;
		}
		.smwpcb_widget_chat .smwpcb_chat_input_field .smwpcb_widget_chat_convers {
		  width: 35px;
		  height: 35px;
		  box-shadow: none;
		  margin: 5px;
		}
		.smwpcb_widget_chat .smwpcb_chat_input_field .smwpcb_widget_chat_convers>i {
		  font-size: 1.6em;
		  line-height: 35px;
		  color: ".smwpcb_adjust_brightness_color($optionsArr['smwpcb_chat_conversation_bg'],-40).";
		}
		.smwpcb_widget_chat .smwpcb_chat_input_field .smwpcb_widget_chat_convers>i:hover {
		  color: ".$optionsArr['smwpcb_prime_font_color_hover'].";
		}
		.smwpcb_widget_chat .smwpcb_chat_conversation_flow {
		  position: relative;
		  background: ".$optionsArr['smwpcb_chat_conversation_bg'].";
		  max-height: 460px;
		  min-height: 0;
		  line-height: ".$optionsArr['smwpcb_chat_line_height']."px;
		  font-size: ".$optionsArr['smwpcb_chat_font_size']."px;
		  height: 100%;
		  overflow-y: auto;
		  width: 100%;
		  float: right;
		}
		.smwpcb_widget_chat .smwpcb-hide-panel {
		  display: none;
		}
		.smwpcb_widget_chat .smwpcb-show-panel {
		  display: block;
		}
		.smwpcb_widget_chat .smwpcb_chat_layout .smwpcb_chat_conversation_flow .smwpcb_message_unit {
		  position: relative;
		  margin: 8px 0 15px 0;
		  max-width: 64%;
		  display: block;
		  padding: 10px;
		  word-wrap: break-word;
		  border-top-right-radius: 1.3em;
		  border-bottom-left-radius: 1.3em;
		  border-bottom-right-radius: 1.3em;
		  border-top-left-radius: 1.3em;
		  -webkit-animation: zoomIn .5s cubic-bezier(.42, 0, .58, 1);
		  animation: zoomIn .5s cubic-bezier(.42, 0, .58, 1);
		  clear: both;
		  z-index: 999;
		}
		.smwpcb_widget_chat .smwpcb_chat_layout .smwpcb_chat_conversation_flow .smwpcb_message_unit .smwpcb_chat_avatar {
		  position: absolute;
		  top: 0;
		}
		.smwpcb_widget_chat .smwpcb_chat_layout .smwpcb_chat_conversation_flow .smwpcb_message_unit.smwpcb_message_unit_agent .smwpcb_chat_avatar {
		  left: -52px;
		  top:-3px;
		}
		.smwpcb_widget_chat .smwpcb_chat_layout .smwpcb_chat_conversation_flow .smwpcb_message_unit .smwpcb_chat_avatar, .smwpcb_widget_chat .smwpcb_chat_avatar img{
		  width: 40px;
		  height: 40px;
		  text-align: center;
		  border-radius: 50%;
		}
		.smwpcb_widget_chat .smwpcb_chat_layout .smwpcb_chat_conversation_flow .smwpcb_message_unit.smwpcb_message_unit_agent {
		  margin-left: 60px;
		  float: left;
		  background: ".$optionsArr['smwpcb_chat_conversation_bg_bot'].";
		  color: ".$optionsArr['smwpcb_chat_conversation_color_bot'].";
		  font-weight: ".$optionsArr['smwpcb_chat_font_weight'].";
		}
		.smwpcb_widget_chat .smwpcb_chat_layout .smwpcb_chat_conversation_flow .smwpcb_message_unit.smwpcb_message_unit_customer {
		  margin-right: 20px;
		  float: right;
		  background: ".$optionsArr['smwpcb_chat_conversation_bg_user'].";
		  color: ".$optionsArr['smwpcb_chat_conversation_color_user'].";
		  font-weight: ".$optionsArr['smwpcb_chat_font_weight'].";
		  border-top-right-radius: 1.3em;
		  border-bottom-left-radius: 1.3em;
		  border-bottom-right-radius: 1.3em;
		  border-top-left-radius: 1.3em;
		}
		.smwpcb_widget_chat .smwpcb_chat_layout .smwpcb_chat_conversation_flow .smwpcb_message_unit.smwpcb_message_unit_agent:before {
		  content: '';
		  position: absolute;
		  top: 13px;
		  left: -11.4px;
		  z-index: 998;
		  border: 6px solid transparent;
		  border-right-color: ".$optionsArr['smwpcb_chat_conversation_bg_bot'].";
		}
		.smwpcb_widget_chat .smwpcb_chat_layout .smwpcb_chat_conversation_flow .smwpcb_message_unit.smwpcb_message_unit_customer:after {
		    content: '';
		    position: absolute;
		    z-index: 998;
		    border: 6px solid transparent;
		    border-left-color: ".$optionsArr['smwpcb_chat_conversation_bg_user'].";
		    right: -11.3px;
		    top: 13px;
		}
		.smwpcb_widget_chat ::-webkit-scrollbar {
		  width: 6px;
		  height: 6px;
		}
		.smwpcb_widget_chat ::-webkit-scrollbar-track {
		  border-radius: 0;
		}
		.smwpcb_widget_chat ::-webkit-scrollbar-thumb {
		  margin: 2px;
		  border-radius: 10px;
		  background: ".smwpcb_adjust_brightness_color($optionsArr['smwpcb_chat_conversation_bg'],-40).";
		}
		.smwpcb_widget_chat .smwpcb_is_active {
		  -webkit-transform: rotate(180deg);
		  transform: rotate(180deg);
		  -webkit-transition: all 1s ease-in-out;
		  transition: all 1s ease-in-out;
		}
		.smwpcb_widget_chat .smwpcb_is_hidden_resize {
		  display: none !important;
		}
		.smwpcb_widget_chat .smwpcb_is_visible_resize {
		  display: block !important;
		}
		.smwpcb_widget_chat .smwpcb_is_float {
		  box-shadow: 0 0 6px rgba(0, 0, 0, .16), 0 6px 12px rgba(0, 0, 0, .32);
		}
		@-webkit-keyframes zoomIn {
		  0% {
		    -webkit-transform: scale(0);
		    transform: scale(0);
		    opacity: 0.0;
		  }
		  100% {
		    -webkit-transform: scale(1);
		    transform: scale(1);
		    opacity: 1;
		  }
		}
		@keyframes zoomIn {
		  0% {
		    -webkit-transform: scale(0);
		    transform: scale(0);
		    opacity: 0.0;
		  }
		  100% {
		    -webkit-transform: scale(1);
		    transform: scale(1);
		    opacity: 1;
		  }
		}
		@-webkit-keyframes load {
		  0% {
		    -webkit-transform: scale(0);
		    transform: scale(0);
		    opacity: 0.0;
		  }
		  50% {
		    -webkit-transform: scale(1.5);
		    transform: scale(1.5);
		    opacity: 1;
		  }
		  100% {
		    -webkit-transform: scale(1);
		    transform: scale(1);
		    opacity: 0;
		  }
		}
		@keyframes load {
		  0% {
		    -webkit-transform: scale(0);
		    transform: scale(0);
		    opacity: 0.0;
		  }
		  50% {
		    -webkit-transform: scale(1.5);
		    transform: scale(1.5);
		    opacity: 1;
		  }
		  100% {
		    -webkit-transform: scale(1);
		    transform: scale(1);
		    opacity: 0;
		  }
		}
		@media only screen and (min-width: 300px) {
		  .smwpcb_widget_chat .smwpcb_chat_layout {
		    width: 100%;
		    height: 100%;
		    right:0;
		    bottom: 0;
		    max-height: 710px;
		  }
		  .smwpcb_widget_chat .smwpcb_chat_input {
		    width: 80% !important;
		  }

		  .smwpcb_widget_chat .smwpcb_header_chat {
		    border-top-left-radius: 0px;
		    border-top-right-radius: 0px;
		  }
		  .smwpcb_widget_chat .smwpcb_chat_conversation_flow {
		    max-height: 660px;
		    border-bottom: 125px solid transparent;
		  }
		  .smwpcb_widget_chat .smwpcb_outer_body_card{
		    -ms-transform: scale(0.9);
		    -moz-transform: scale(0.9);
		    -webkit-transform: scale(0.9);
		    transform: scale(0.9);
		    margin-left: 0 !important;
		    margin-right: 0 !important;
		    text-align: left;
		  }
		}
		@media only screen and (min-width: 480px) {
		  .smwpcb_widget_chat .smwpcb_chat_layout {
		    width: 100%;
		    height: 100%;
		    right:0;
		    bottom: 0;
		    max-height: 710px;
		  }
		  .smwpcb_widget_chat .smwpcb_chat_input {
		    width: 88% !important;
		  }
		  .smwpcb_widget_chat .smwpcb_chat_conversation_flow {
		    max-height: 660px;
		    border-bottom: 125px solid transparent;
		  }

		  .smwpcb_widget_chat .smwpcb_header_chat {
		    border-top-left-radius: 0px;
		    border-top-right-radius: 0px;
		  }
		  .smwpcb_widget_chat .smwpcb_outer_body_card{
		    -ms-transform: scale(1);
		    -moz-transform: scale(1);
		    -webkit-transform: scale(1);
		    transform: scale(1);
		    margin-left: 0 !important;
		    margin-right: 0 !important;
		    text-align: left;
		  }
		}
		@media only screen and (min-width: 768px) {
		  .smwpcb_widget_chat .smwpcb_chat_layout {
		    width: 400px;
		    height: 1000px;
		    right:".$optionsArr['smwpcb_chat_pos_right_chat']."px;
		    bottom: ".$optionsArr['smwpcb_chat_pos_bottom_chat']."px;
		    max-height: 530px;
		  }
		  .smwpcb_widget_chat .smwpcb_chat_input {
		    width: 85% !important;
		  }
		  .smwpcb_widget_chat .smwpcb_header_chat {
		    border-top-left-radius: 10px;
		    border-top-right-radius: 10px;
		  }
		  .smwpcb_widget_chat .smwpcb_chat_conversation_flow {
		    max-height: 460px;
		    border-bottom: 50px solid transparent;
		  }
		  .smwpcb_widget_chat .smwpcb_outer_body_card{
		    -ms-transform: scale(1);
		    -moz-transform: scale(1);
		    -webkit-transform: scale(1);
		    transform: scale(1);
		    margin-left: 0 !important;
		    margin-right: 0 !important;
		    text-align: left;
		  }
		}
		@media only screen and (min-width: 1024px) {
		  .smwpcb_widget_chat .smwpcb_chat_layout {
		    width: 400px;
		    height: 1000px;
		    right: ".$optionsArr['smwpcb_chat_pos_right_chat']."px;
		    bottom: ".$optionsArr['smwpcb_chat_pos_bottom_chat']."px;
		    max-height: 530px;
		  }
		  .smwpcb_widget_chat .smwpcb_chat_input {
		    width: 85% !important;
		  }
		  .smwpcb_widget_chat .smwpcb_header_chat {
		    border-top-left-radius: 10px;
		    border-top-right-radius: 10px;
		  }
		  .smwpcb_widget_chat .smwpcb_chat_conversation_flow {
		    max-height: 460px;
		    border-bottom: 50px solid transparent;
		  }
		  .smwpcb_widget_chat .smwpcb_outer_body_card{
		    -ms-transform: scale(1);
		    -moz-transform: scale(1);
		    -webkit-transform: scale(1);
		    transform: scale(1);
		    margin-left: 0 !important;
		    margin-right: 0 !important;
		  }
		}

		.smwpcb_widget_chat ::-webkit-input-placeholder { 
		  color: ".smwpcb_adjust_brightness_color($optionsArr['smwpcb_chat_conversation_bg'],-40).";
		}
		.smwpcb_widget_chat :-ms-input-placeholder {
		  color: ".smwpcb_adjust_brightness_color($optionsArr['smwpcb_chat_conversation_bg'],-40).";
		}
		.smwpcb_widget_chat ::-moz-placeholder {
		  color: ".smwpcb_adjust_brightness_color($optionsArr['smwpcb_chat_conversation_bg'],-40).";
		}
		.smwpcb_widget_chat :-moz-placeholder {
		  color: ".smwpcb_adjust_brightness_color($optionsArr['smwpcb_chat_conversation_bg'],-40).";
		}
		@keyframes fade-in-right {
		  from {
		    opacity: 0;
		    transform: translate(0px,-50px);
		  }
		  to {
		    opacity: 1;
		    transform: translate(0px,-100px);
		  }
		}
		.smwpcb_widget_chat .smwpcb_card_fullscreen{
		  margin-right: 5px;
		}
		.smwpcb_widget_chat .smwpcb_chat_description{
		  margin-top: 140px;
		  display: block;
		  margin-left: auto;
		  margin-right: auto;
		  width: 50%;
		  opacity: 0;
		  animation: fade-in-right ease 1.6s forwards;
		}
		.smwpcb_widget_chat .smwpcb_chat_description p{
		  font-weight: bold;
		  text-align: center;
		  color: ".$optionsArr['smwpcb_chat_conversation_color'].";
		  margin: 17px 5px 5px 5px;
		  font-size:18px;
		}
		.smwpcb_widget_chat .smwpcb_chat_description p.smwpcb_ag_occup{
		  font-weight: normal;
		  margin-top: 5px;
		  font-size: 18px;
		}
		.smwpcb_widget_chat .smwpcb_chat_description img{
		   border-radius: 50%;
		   width :150px;
		   height:150px;
		   display: block;
		   margin-left: auto;
		   margin-right: auto;

		}
		.smwpcb_widget_chat .smwpcb_chat_description #smwpcb_ag_rating{
		  margin: 5px;
		  color: ".$optionsArr['smwpcb_chat_conversation_bg_user'].";
		}
		.smwpcb_widget_chat #smwpcb_agent_name{
		  font-weight: bold;
		}
		.smwpcb_widget_chat .smwpcb_rating_star1{
		  animation: smwpcbfadein 1s;
		}
		.smwpcb_widget_chat .smwpcb_rating_star2{
		  animation: smwpcbfadein 1.2s;
		}
		.smwpcb_widget_chat .smwpcb_rating_star3{
		  animation: smwpcbfadein 1.4s;
		}
		.smwpcb_widget_chat .smwpcb_rating_star4{
		  animation: smwpcbfadein 1.6s;
		}
		.smwpcb_widget_chat .smwpcb_rating_star5{
		  animation: smwpcbfadein 1.8s;
		}
		@keyframes smwpcbfadein {
		  from {
		    opacity: 1;
		  }
		  to {
		    opacity: 0;
		  }
		}
		.smwpcb_widget_chat a {
		  text-decoration: none;
		}
		.smwpcb_widget_chat a:hover, .smwpcb_widget_chat a:focus, .smwpcb_widget_chat a:active {
		  text-decoration: none;
		}
		.smwpcb_widget_chat .smwpcb_outer_body_card{
		  max-width: 87%; 
		  margin-top: 10px;
		  margin-bottom: 10px;
		}
		.smwpcb_widget_chat .smwpcb_card_component{
		  min-width:295px;
		}
		.smwpcb_widget_chat .smwpcb_card_footer #smwpcb_card_prev,
		.smwpcb_widget_chat .smwpcb_card_footer #smwpcb_card_next,
		.smwpcb_widget_chat .smwpcb_card_footer .smwpcb_card_fancy_button,
		.smwpcb_widget_chat .smwpcb_card_footer .smwpcb_card_fancy_button:hover{
		  -webkit-box-shadow: none;
		  box-shadow: none;
		  -webkit-transition: none;
		  transition: none;
		  transition: none;
		  transition: none;
		}
		.smwpcb_widget_chat .smwpcb_card_products a{
		  -webkit-box-shadow: none !important; 
		  box-shadow: none !important;
		}
		.smwpcb_widget_chat .smwpcb_card_products .smwpcb_card_description{
		  max-height: 85px;
		  overflow: hidden;
		  font-weight: 500;
		}
	 .smwpcb_widget_chat .smwpcb_writing_dot {
	    display:inline-block;
	    width:8px;
	    height:8px;
	    border-radius:50%;
	    margin-right:1.5px;
	    background:".$optionsArr['smwpcb_chat_conversation_color_bot'].";
	    animation: smwpcbwave 1.3s linear infinite;
	  }
	  .smwpcb_widget_chat .smwpcb_writing_dot:nth-child(2) {
	      animation-delay: -1.1s;
	    }

	  .smwpcb_widget_chat .smwpcb_writing_dot:nth-child(3) {
	    animation-delay: -0.9s;
	  }

		@keyframes smwpcbwave {
		  0%, 60%, 100% {
		    transform: initial;
		  }
		  30% {
		    transform: translateY(-8px);
		  }
		}
		.smwpcb_widget_chat .smwpcb_quick_replies li {
		  margin-right: 5px !important;
		}
		.smwpcb_widget_chat .smwpcb_animate_replies{
		  -webkit-animation: zoomIn .5s ease-in-out;
		  animation: zoomIn .5s ease-in-out;
		}
		.smwpcb_widget_chat .smwpcb_card_animate{
		  transition: all 0.1s !important;
		  -webkit-transition: all 0.1s !important;
		}
		.smwpcb_widget_chat .smwpcb_card_action_button{
		  position: relative;
		  padding: 10px 10px;
		  border-radius: 8px;
		  box-shadow: none !important;
		  color: ".$optionsArr['smwpcb_chat_conversation_color_user']." !important;
		  text-decoration: none !important; 
		  min-width: 200px;
		  margin-bottom: 5px; 
		}
		.smwpcb_widget_chat .smwpcb_card_red{
		  background-color: ".$optionsArr['smwpcb_chat_conversation_bg_user']." !important;
		  border-bottom: 5px solid ".$optionsArr['smwpcb_chat_conversation_bg_user_darker']." !important;
		}
		.smwpcb_widget_chat .smwpcb_card_action_button:active,
		.smwpcb_widget_chat .smwpcb_card_action_button:hover{
		  border-bottom: 1px solid !important;
		}
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:active,
		.smwpcb_widget_chat .smwpcb_widget_chat_convers:hover{
		  color: ".$optionsArr['smwpcb_chat_conversation_bg_user']." !important;
		}
		.smwpcb_widget_chat .smwpcb_card_red_notification{
		  background: red !important;
		}
		.smwpcb_widget_chat .smwpcb_card_bodycard {
		  color: rgba(0, 0, 0, 0.6);
		  font-family: 'Roboto', sans-serif;
		  font-size: 14px;
		  line-height: 1.6em;
		  -webkit-font-smoothing: antialiased;
		  -moz-osx-font-smoothing: grayscale;
		  -webkit-transition: 0.5s ease;
		  transition: 0.5s ease;
		}
		.smwpcb_widget_chat .smwpcb_card_btn {
		  border-radius: 2px;
		  padding: 8px 12px;
		  color: ".$optionsArr['smwpcb_chat_conversation_bg_user'].";
		  font-size: 14px;
		  font-weight: 500;
		  text-decoration: none;
		  text-transform: uppercase;
		  -webkit-transition: 0.5s ease;
		  transition: 0.5s ease;
		}
		.smwpcb_widget_chat .smwpcb_card_component {
		  max-height: 375px;
		  background: #FFFFFF;
		  max-width: 400px;
		  border-radius: 12px;
		  box-shadow: 0 10px 20px rgba(0, 0, 0, 0.19), 0 6px 6px rgba(0, 0, 0, 0.23);
		  box-sizing: border-box;
		  padding: 20px;
		  text-align: center;
		}
		.smwpcb_widget_chat .smwpcb_card_products {
		  position: relative;
		  overflow: hidden;
		  -webkit-transition: 0.5s ease;
		  transition: 0.5s ease;
		  height: 340px;
		}
		.smwpcb_widget_chat .smwpcb_card_product {
		  position: absolute;
		  top: 0;
		  left: 0;
		  opacity: 0;
		  visibility: hidden;
		  -webkit-transition: 0.5s ease;
		  transition: 0.5s ease;
		}
		.smwpcb_widget_chat .smwpcb_card_product.smwpcb_card_item_active {
		  opacity: 1;
		  visibility: visible;
		}
		.smwpcb_widget_chat .smwpcb_card_thumbnail {
		  margin: 0 0 48px;
		}
		.smwpcb_widget_chat .smwpcb_card_thumbnail img{
		  max-height: 166px;
		}
		.smwpcb_widget_chat .smwpcb_card_title {
		  margin: 0 0 12px;
		  line-height: 24px;
		  font-size: 20px;
		  -webkit-transition: 0.5s ease;
		  transition: 0.5s ease;
		}
		.smwpcb_widget_chat .smwpcb_card_footer {
		  display: -webkit-box;
		  display: -ms-flexbox;
		  display: flex;
		  -webkit-box-orient: horizontal;
		  -webkit-box-direction: normal;
		      -ms-flex-direction: row;
		          flex-direction: row;
		  -webkit-box-pack: justify;
		      -ms-flex-pack: justify;
		          justify-content: space-between;
		  margin: 0 -12px -12px;
		  position:relative;
		}
		.smwpcb_widget_chat .smwpcb_card_footer #smwpcb_card_prev {
		  bottom: 180px;
		  font-size: 29px; 
		  margin-left: -29px;
		}
		.smwpcb_widget_chat .smwpcb_card_footer #smwpcb_card_next {
		  bottom: 180px;
		  font-size: 29px;
		  margin-right: -29px;
		}
		[smwpcb_card_ripple] {
		  z-index: 1;
		  position: relative;
		  overflow: hidden;
		}
		[smwpcb_card_ripple] .smwpcb_widget_chat .smwpcb_card_ripple {
		  position: absolute;
		  background: #FFFFFF;
		  width: 60px;
		  height: 60px;
		  border-radius: 100%;
		  -webkit-transform: scale(0);
		          transform: scale(0);
		  -webkit-animation: ripple 2s;
		          animation: ripple 2s;
		}

		@-webkit-keyframes ripple {
		  0% {
		    -webkit-transform: scale(0);
		            transform: scale(0);
		    opacity: 0.2;
		  }
		  100% {
		    -webkit-transform: scale(20);
		            transform: scale(20);
		    opacity: 0;
		  }
		}

		@keyframes ripple {
		  0% {
		    -webkit-transform: scale(0);
		            transform: scale(0);
		    opacity: 0.2;
		  }
		  100% {
		    -webkit-transform: scale(20);
		            transform: scale(20);
		    opacity: 0;
		  }
		}

		.smwpcb_widget_chat .zmdi-comment-outline:before {
	      content: '\\".$optionsArr['smwpcb_prime_icon_msg']."' !important;
	    }

    .smwpcb_widget_chat .zmdi-close:before {
      content: '\\".$optionsArr['smwpcb_prime_icon_x']."' !important;
    }";

    fwrite($myfile, $str);
    fclose($myfile);

    update_option('smwpcb_custom_design_version', intval(get_option('smwpcb_custom_design_version'))+1);


  }

}

/**
 * contruct the array of the custom widget user interface options.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_contruct_ui_settings')){

  function smwpcb_contruct_ui_settings($postedArr){

    $optionsArr['smwpcb_prime_width'] = ((isset($postedArr['smwpcb_prime_width'])) ? $postedArr['smwpcb_prime_width'] : '70');
    $optionsArr['smwpcb_prime_icon_size'] = ((isset($postedArr['smwpcb_prime_icon_size'])) ? $postedArr['smwpcb_prime_icon_size'] : '32');
    $optionsArr['smwpcb_prime_icon_msg'] = ((isset($postedArr['smwpcb_prime_icon_msg'])) ? $postedArr['smwpcb_prime_icon_msg'] : 'f261');
    $optionsArr['smwpcb_prime_icon_x'] = ((isset($postedArr['smwpcb_prime_icon_x'])) ? $postedArr['smwpcb_prime_icon_x'] : 'f136');
    $optionsArr['smwpcb_message_sound'] = ((isset($postedArr['smwpcb_message_sound'])) ? $postedArr['smwpcb_message_sound'] : 'when.mp3');
    $optionsArr['smwpcb_chat_pos_right'] = ((isset($postedArr['smwpcb_chat_pos_right'])) ? $postedArr['smwpcb_chat_pos_right'] : '16');
    $optionsArr['smwpcb_chat_pos_right_chat'] = ((isset($postedArr['smwpcb_chat_pos_right_chat'])) ? $postedArr['smwpcb_chat_pos_right_chat'] : '16');
    $optionsArr['smwpcb_chat_pos_bottom'] = ((isset($postedArr['smwpcb_chat_pos_bottom'])) ? $postedArr['smwpcb_chat_pos_bottom'] : '16');
    $optionsArr['smwpcb_chat_pos_bottom_chat'] = ((isset($postedArr['smwpcb_chat_pos_bottom_chat'])) ? $postedArr['smwpcb_chat_pos_bottom_chat'] : '90');
    $optionsArr['smwpcb_chat_font_size'] = ((isset($postedArr['smwpcb_chat_font_size'])) ? $postedArr['smwpcb_chat_font_size'] : '15');
    $optionsArr['smwpcb_chat_font_weight'] = ((isset($postedArr['smwpcb_chat_font_weight'])) ? $postedArr['smwpcb_chat_font_weight'] : '600');
    $optionsArr['smwpcb_chat_line_height'] = ((isset($postedArr['smwpcb_chat_line_height'])) ? $postedArr['smwpcb_chat_line_height'] : '19');
    $optionsArr['smwpcb_prime_background'] = ((isset($postedArr['smwpcb_prime_background'])) ? $postedArr['smwpcb_prime_background'] : '#2f3037');
    $optionsArr['smwpcb_prime_font_color'] = ((isset($postedArr['smwpcb_prime_font_color'])) ? $postedArr['smwpcb_prime_font_color'] : '#f0f0f0');
    $optionsArr['smwpcb_prime_font_color_hover'] = ((isset($postedArr['smwpcb_prime_font_color_hover'])) ? $postedArr['smwpcb_prime_font_color_hover'] : '#f33462');
    $optionsArr['smwpcb_chat_conversation_bg'] = ((isset($postedArr['smwpcb_chat_conversation_bg'])) ? $postedArr['smwpcb_chat_conversation_bg'] : '#e9e9e9');
    $optionsArr['smwpcb_chat_conversation_bg_bot'] = ((isset($postedArr['smwpcb_chat_conversation_bg_bot'])) ? $postedArr['smwpcb_chat_conversation_bg_bot'] : '#ffffff');
    $optionsArr['smwpcb_chat_conversation_bg_user'] = ((isset($postedArr['smwpcb_chat_conversation_bg_user'])) ? $postedArr['smwpcb_chat_conversation_bg_user'] : '#f33462');
    $optionsArr['smwpcb_chat_conversation_color'] = ((isset($postedArr['smwpcb_chat_conversation_color'])) ? $postedArr['smwpcb_chat_conversation_color'] : '#585858');
    $optionsArr['smwpcb_chat_conversation_color_bot'] = ((isset($postedArr['smwpcb_chat_conversation_color_bot'])) ? $postedArr['smwpcb_chat_conversation_color_bot'] : '#000000');
    $optionsArr['smwpcb_chat_conversation_color_user'] = ((isset($postedArr['smwpcb_chat_conversation_color_user'])) ? $postedArr['smwpcb_chat_conversation_color_user'] : '#fef1f2');
    if($postedArr != array()){
      update_option('smwpcb_cb_ui_custom_settings', $optionsArr);
      return array();
    }else{
      return $optionsArr;
    }

  }

}


?>