<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Check if code licence is duplicated.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_chatbot_has_dupes')){

  function smwpcb_wp_chatbot_has_dupes($array) {

      $dupe_array = array();
      foreach ($array as $key => $val) {
          if (++$dupe_array[$val] > 1) {
              return $key;
          }
      }
      return false;
  }

}
if (!function_exists('smwpcb_wp_chatbot_array_has_dupes')){

  function smwpcb_wp_chatbot_array_has_dupes($array) {
    if(count($array) != 1){
     return count($array) === count(array_unique($array));
    }else{
      return false;
    }
  }

}

/**
 * Code licence verification.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_chatbot_code_licence')){

    function smwpcb_wp_chatbot_code_licence() {

      $smwpcb_wp_chatbot_code_licence_settings = get_option('smwpcb_wp_chatbot_code_licence_settings');
      if (isset($_POST['smwpcb_wp_code_licence_submit']) && check_admin_referer(plugin_basename(__FILE__), 'smwpcb_wp_code_licence_nonce_name')) {
        echo "<meta http-equiv='refresh' content='0'>";
        $count = 1;
        foreach ($smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence'] as $key => $codelicence) {
          if(isset($_POST[$key])){
            $code = trim($_POST[$key]);
            if (preg_match("/^(\w{8})-((\w{4})-){3}(\w{12})$/", $code)){
              $code_verification = smwpcb_wp_verify_code_licence($code,$count);
              if($code_verification[0]){
                $smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence'][$key] = $code;
                if(smwpcb_wp_chatbot_has_dupes($smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence']) === false){
                  $message .= __(((empty($message))?"":"<br>").$code_verification[1], 'smart-wordpress-chatbot');
                }else{
                  $smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence'][$key] = '';
                  $error .= __(((empty($error))?"":"<br>").'The purchase code#'.$count.' provided is duplicated.', 'smart-wordpress-chatbot');
                }           
              }else{
                $smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence'][$key] = '';
                $error .= __(((empty($error))?"":"<br>").$code_verification[1], 'smart-wordpress-chatbot');
              }
            }else{
              $smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence'][$key] = '';
              $error .= __(((empty($error))?"":"<br>")."Please enter a valid code licence.", 'smart-wordpress-chatbot');
            }
            update_option('smwpcb_wp_chatbot_code_licence_settings', $smwpcb_wp_chatbot_code_licence_settings);
          }
          $count++; 
        }
      }
      ?>
      <div class="wrap">
      <h1 class="wp-heading-inline">Maxbot - Chatbot builder Wordpress plugin</h1>
      <p>The License grants you, the purchaser, an ongoing, non-exclusive, worldwide license to make use of the digital work Maxbot you have bought.</p>
      <p>You are licensed to use this plugin to create one single End Product for yourself or for a client, in this case the item is this plugin and the end product is the final website customised with your content, You can make multiple purshases to get more accessilibity of this plugin.</p>
      <div class="updated fade smwpcb_fixupdated" <?php if (empty($message)) echo "style=\"display:none;\""; ?>>
        <p><strong><?php echo $message; ?></strong></p>
      </div>
      <div class="error" <?php if (empty($error)) echo "style=\"display:none;\""; ?>>
        <p><strong><?php echo $error; ?></strong></p>
      </div>
      <form action="" method="post">
        <table class="form-table">
        <tbody>
            <tr>
                <th scope="row"><label for="smwpcb_wp_code_licence"><?php _e('Code Licence', 'smart-wordpress-chatbot'); ?></label></th>
                <td>
                    <div class="smwpcb_code_licences" itemkeys="<?= count($smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence']) ?>" style="display: inline-block;">
                    <?php
                    foreach ($smwpcb_wp_chatbot_code_licence_settings['smwpcb_wp_code_licence'] as $k => $code_purchase) {
                     if($k == 'smwpcb_code_licence0'){
                        ?>
                        <input type="text" id="smwpcb_wp_code_licence" style="width:320px"  name="<?= $k ?>" placeholder="xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" value="<?php echo $code_purchase ?>" required>
                        <button type="button" class="button" id="smwpcb_addcodelicence">Add More</button>
                        <?php
                      }else{
                        ?>
                        <br>
                        <input type="text" style="width:320px" name="<?= $k ?>" placeholder="xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" value="<?php echo $code_purchase ?>" required>
                        <button type="button" class="button smwpcb_deletecodelicence" idkey="<?= substr($k, 19) ?>" >Delete</button>
                        <?php
                      }
                    }
                    ?>
                    </div>
                    <p class="description"><?php _e('Please enter your code licence.', 'smart-wordpress-chatbot'); ?></p>
                </td>
            </tr>
        </tbody>
        </table>
        <p class="submit">
            <input type="submit" id="define-page-attachment" class="button-primary" value="<?php _e('Activate', 'smart-wordpress-chatbot') ?>" />
            <input type="hidden" name="smwpcb_wp_code_licence_submit" value="submit" />
            <?php wp_nonce_field(plugin_basename(__FILE__), 'smwpcb_wp_code_licence_nonce_name'); ?>
        </p>  
        </form>
        

          <h4><strong>Your Code licence(s) empowers you with these benefits: </strong></h4>
          <ul style="-webkit-column-count: 3;-moz-column-count: 3;column-count: 3;margin-bottom: 0px !important;">
          <li><?php echo( ($smwpcb_wp_code_licence_empower[5] > '2020-05-15') ? '<strong>'.$smwpcb_wp_code_licence_empower[1].'</strong> Days access' : '<strong>Lifetime</strong> access' )?></li>
          <li><strong><?= $smwpcb_wp_code_licence_empower[2] ?></strong> Days of Support </li>
          <li><?php echo((count($smwpcb_wp_code_licence_empower[4]) == 1) ? 'This is ' : 'These are ')?><strong><?php echo((smwpcb_wp_chatbot_array_has_dupes($smwpcb_wp_code_licence_empower[4]) === true) ? 'Regular and Extended Licence' : $smwpcb_wp_code_licence_empower[4][0]).((count($smwpcb_wp_code_licence_empower[4]) == 1) ? '' : 's')?></strong></li>
          <li><strong><?= ($smwpcb_wp_code_licence_empower[0] > 15) ? 'Unlimited' : $smwpcb_wp_code_licence_empower[0] ?></strong> Projects </li> 
          <li><strong><?= ($smwpcb_wp_code_licence_empower[0] > 15) ? 'Unlimited' : $smwpcb_wp_code_licence_empower[0] ?></strong> Columns Table </li>
          <li><strong>Unlimited</strong> Agents </li>
          <li><strong>Unlimited</strong> Topics </li>
          <li><strong>Unlimited</strong> Conversations </li>
          <li><strong>Unlimited</strong> User Data Entries </li>
          </ul>
        
        <hr>
        <h4><strong>How to find your purchase code ?</strong></h4>
        <ol>
          <li>Log into your CodeCanyon Market account.</li>
          <li>Hover the mouse over your username at the top of the screen.</li>
          <li>Click ‘Downloads’ from the drop-down menu.</li>
          <li>Click ‘License certificate & purchase code’ (available as PDF or text file).</li>
        </ol>
        <p>Here is an example of a PDF License certificate and purchase code:</p>
        <p style="text-align:center;"><img style="height:290px;max-width:100%;" src="https://help.market.envato.com/hc/en-us/article_attachments/201801083/License_Purchase_Code_Example.png" alt=""></p>
        <h4><strong>Do I need to buy a new license if I use the plugin in a another domaine ?</strong></h4>
        <p>As long as the licence hasn't been expired, a single license is fine.</p>
        <h4><strong>If I purchase an Extended License, do I get a multi-use, multi-client or developer license ?</strong></h4>
        <p>No. The Extended License is still limited to a single end product.</p>
        <h4><strong>Can I use Maxbot on a test site, then move it to a live site when finished ?</strong></h4>
        <p>Yes, you can. You can keep the theme on a test site to build it, then move it to the live site once you’re finished.</p>
        </div>
      <?php

    }

}

/**
 * What code licences empowers users.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_code_licence_empower')) {

    function smwpcb_wp_code_licence_empower() {

      return array(
        0=>999, 
        1=>'1 year', 
        2=>'1 year', 
        3=>'buyer', 
        4=>'xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx', 
        5=>'2020-05-15'
      );

    }

}

/**
 * Verify code licence.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_verify_code_licence')) {

    function smwpcb_wp_verify_code_licence($code,$count) {
        
        return array(
          0=>true, 
          1=>"The purchase code #".$count." provided is valid.",
          2=>15, 
          3=>array(
            0=>'2020-05-01',
            1=>'xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx',
            2=>'buyer',
            3=>'2021-05-01'
          ));

    }

}