<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Maxbot general settings where you can change some 
 * fundamental options on the chatbot.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_chatbot_general_settings')){

    function smwpcb_wp_chatbot_general_settings() {

		  $smwpcb_chatbots_general_settings = get_option('smwpcb_chatbots_general_settings');
		  $message = '';
		  if (isset($_POST['page_chatbots_general_primary_settings']) && check_admin_referer(plugin_basename(__FILE__), 'general_primary_settings_admin_referer')) {
		  $smwpcb_chatbots_general_settings['smwpcb_chatbots_conversation_starter'] = (isset($_POST['smwpcb_chatbots_conversation_starter']) && intval($_POST['smwpcb_chatbots_conversation_starter']) != 0) ? sanitize_text_field($_POST['smwpcb_chatbots_conversation_starter']) : 0;
		  $smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_autogreeting'] = (isset($_POST['smwpcb_chatbots_timeout_autogreeting']) && intval($_POST['smwpcb_chatbots_timeout_autogreeting']) != 0) ? sanitize_text_field($_POST['smwpcb_chatbots_timeout_autogreeting']) : 1;
		  $smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_responsing'] = (isset($_POST['smwpcb_chatbots_timeout_responsing']) && intval($_POST['smwpcb_chatbots_timeout_responsing']) != 0)  ? sanitize_text_field($_POST['smwpcb_chatbots_timeout_responsing']) : 1;
		  $smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_writing'] = (isset($_POST['smwpcb_chatbots_timeout_writing']) && intval($_POST['smwpcb_chatbots_timeout_writing']) != 0)  ? sanitize_text_field($_POST['smwpcb_chatbots_timeout_writing']) : 1;
      $smwpcb_chatbots_general_settings['smwpcb_delete_maxbot_data'] = (isset($_POST['smwpcb_delete_maxbot_data']) && intval($_POST['smwpcb_delete_maxbot_data']) != 0) ? sanitize_text_field($_POST['smwpcb_delete_maxbot_data']) : 0;
      

		  $message = "Settings were saved correctly.";
		  update_option( 'smwpcb_chatbots_general_settings', $smwpcb_chatbots_general_settings );
		  }
		  ?>
	    <div class="wrap">
		    <h1 class="wp-heading-inline"><?php esc_html_e('General Settings', 'smart-wordpress-chatbot'); ?></h1>
		    <?php echo((smwpcb_rate_the_plugin() != '') ? smwpcb_rate_the_plugin() : ''); ?>
		    <div class="updated <?php if (empty($message)) echo "smwpcb_gs_message" ?>" >
        <p><strong><?php echo($message); ?></strong></p>
        </div>
        <div id="poststuff">
		    <div id="post-body">
          <div class="postbox">
              <div class="inside">
                <form autocomplete="off" id="smwpcb_settings_form" method="post" action="">
                  <table class="form-table">
                      <tbody>
                          <tr valign="top">
                              <th scope="row"><?php esc_html_e("Conversation Starter", 'smart-wordpress-chatbot'); ?></th>
                              <td>
                                  <label class="smwpcb_switch_toggle">
                                    <input type="checkbox" value="1" id="smwpcb_chatbots_conversation_starter" name="smwpcb_chatbots_conversation_starter" <?php checked( esc_attr($smwpcb_chatbots_general_settings['smwpcb_chatbots_conversation_starter']), "1", true )?>>
                                    <div class="smwpcb_toggle round"></div>
                                  </label>
                                  <br>
                                  <p class="description"><?php esc_html_e('Enable the bot to start the conversation when the page loads after a certain timeout, otherwise it starts the conversation when the users clicks on the widget.', 'smart-wordpress-chatbot'); ?></p>
                              </td>
                          </tr>
                          <?php
                            if($smwpcb_chatbots_general_settings['smwpcb_chatbots_conversation_starter'] == "1")
                              echo("<tr id='conversation_starter_toggle' class='smwpcb_display_table' valign='top'>");
                            else
                              echo("<tr id='conversation_starter_toggle' class='smwpcb_display_none' valign='top'>");
                          ?>
                                  <th scope="row"><?php esc_html_e("Time waiting until the first message", 'smart-wordpress-chatbot'); ?></th>
                                  <td>
                                      <input type="number" min="1" name="smwpcb_chatbots_timeout_autogreeting" value="<?php echo esc_attr($smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_autogreeting']); ?>" placeholder="1"/>
                                      <br>
                                      <p class="description"><?php esc_html_e('Set a timeout before the bot starts the conversation. That is how many seconds after a visitor arrives to the site the chatbot will send the initial message.', 'smart-wordpress-chatbot'); ?>
                                      </p> 
                                  </td>
                              </tr>
                          <tr valign="top">
                            <th scope="row"><?php esc_html_e('Time waiting until the chatbot responds', 'smart-wordpress-chatbot'); ?></th>
                            <td>
                                <input type="number" min="1" name="smwpcb_chatbots_timeout_responsing" placeholder="1" value="<?php echo esc_attr($smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_responsing']); ?>"/>
                                <br>
                                <p class="description"><?php esc_html_e("Set a timeout for the bot's reponding time. That is how many seconds it takes to respond to a visitor.", 'smart-wordpress-chatbot'); ?>
                                </p>
                            </td>
                          </tr>
                          <tr valign="top">
                              <th scope="row"><?php esc_html_e('Time it takes the chatbot to write answers', 'smart-wordpress-chatbot'); ?></th>
                              <td>
                                  <input type="number" min="1" name="smwpcb_chatbots_timeout_writing" placeholder="1" value="<?php echo esc_attr($smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_writing']); ?>"/>
                                  <br>
                                  <p class="description"><?php esc_html_e("Set a timeout for the bot's writing time. That is how many seconds it takes to write a message.", 'smart-wordpress-chatbot'); ?>
                                  </p>
                              </td>
                          </tr>
                          <tr valign="top">
                              <th scope="row"><?php esc_html_e("Delete data after uninstallation", 'smart-wordpress-chatbot'); ?></th>
                              <td>
                                  <label class="smwpcb_switch_toggle">
                                    <input type="checkbox" value="1" id="smwpcb_delete_maxbot_data" name="smwpcb_delete_maxbot_data" <?php checked( esc_attr($smwpcb_chatbots_general_settings['smwpcb_delete_maxbot_data']), "1", true )?>>
                                    <div class="smwpcb_toggle round"></div>
                                  </label>
                                  <br>
                                  <p class="description"><?php esc_html_e('Check this option if you do not want to keep data configured from this plugin after uninstallation.', 'smart-wordpress-chatbot'); ?></p>
                              </td>
                          </tr>
                      </tbody>
                  </table>
                  <p class="submit">
                      <input type="submit" class="button-primary" value="<?php esc_html_e('Save Changes', 'smart-wordpress-chatbot') ?>" />
                      <input type="hidden" name="page_chatbots_general_primary_settings" value="submit" />
                      <?php wp_nonce_field(plugin_basename(__FILE__), 'general_primary_settings_admin_referer'); ?>
                  </p>
                </form>
              </div>
            </div>
	        </div>
	      </div>     
	    </div>
	    <?php

    }

}



?>