<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Consult, edit, remove the collected data
 * Page option.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_wp_users_data')){

    function smwpcb_wp_users_data() {

      $smwpcb_data_tables_settings = get_option('smwpcb_data_tables_settings');
      if(isset($_GET['currentpage']) && is_numeric($_GET['currentpage'])){
        $currentpage = (int) $_GET['currentpage'];
      }else{
        $currentpage = 1;
      }
      $numrows = count(smwpcb_retrieve_users_data_analytics_results());
      $rowsperpage = 10;
      $totalpages = ceil($numrows / $rowsperpage);
      if($currentpage > $totalpages){
        $currentpage = $totalpages;
      } 
      if($currentpage < 1){
        $currentpage = 1;
      }
      $smwpcb_users_data_analytics_settings = smwpcb_retrieve_users_data_analytics_results_btw2(($currentpage - 1) * $rowsperpage,$rowsperpage);
      ?>
      <div class="wrap">
      <h1 class="wp-heading-inline"><?php esc_html_e('Users Data', 'smart-wordpress-chatbot'); ?></h1>
      <?php echo((smwpcb_rate_the_plugin() != '') ? smwpcb_rate_the_plugin() : ''); 
      if(count($smwpcb_data_tables_settings) == 0){
        echo('<div class="notice notice-warning"><p>');
        esc_html_e('Please create column data in order for the chatbot to get information out of users.', 'smart-wordpress-chatbot');
        echo('</p></div>');
      }
      ?>
      <div class="tablenav top">
        <div class="alignleft actions bulkactions">
            <label for="bulk-action-selector-top" class="screen-reader-text"><?php esc_html_e('Select bulk action', 'smart-wordpress-chatbot'); ?></label>
            <select name="action" id="bulk-action-selector-top">
                <option value=""><?php esc_html_e('Bulk Actions', 'smart-wordpress-chatbot'); ?></option>
                <option value="delete-selected-data-users"><?php esc_html_e('Delete', 'smart-wordpress-chatbot'); ?></option>
            </select>
            <input type="submit" class="button" id="applyUserData" value="<?php esc_html_e('Apply', 'smart-wordpress-chatbot'); ?>">
        </div>
      </div>
        <table class="smwpcb_table_fix widefat striped smwpcb_users_data">
          <thead>
              <tr>
                  <td id="cb" class="manage-column column-cb check-column smwpcb_column_fix">
                      <label class="screen-reader-text" for="cb-select-all-1"><?php esc_html_e('Select All', 'smart-wordpress-chatbot'); ?><</label>
                      <input id="cb-select-all-1" type="checkbox" value="">
                  </td>
                  <th scope="col" class="manage-column sortable desc smwpcb_min_wdth"><a href="javascript:void(0)"><span><?php esc_html_e('Date', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span></a></th>
                  <?php
                  for ($j=0; $j < count($smwpcb_data_tables_settings) ; $j++) {
                  ?>
                  <th scope="col" class="manage-column sortable desc smwpcb_min_wdth"><a href="javascript:void(0)"><span><?= stripslashes($smwpcb_data_tables_settings[$j]['name']) ?></span><span class="sorting-indicator"></span> </a></th>
                  <?php
                  }
                  ?>
                  <th scope="col" class="manage-column sortable desc smwpcb_min_wdth"><a href="javascript:void(0)"><span><?php esc_html_e('Users responses', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
              </tr>
          </thead>
          <tbody id="the-list">
              <?php
              if(count($smwpcb_users_data_analytics_settings) == 0){
                echo('<tr>');
                echo('<td class="row-title" colspan="'.(3+count($smwpcb_data_tables_settings)).'">');
                esc_html_e('There\'s no users data yet.', 'smart-wordpress-chatbot');
                echo('</td>');
                echo('</tr>');
              }else{
                foreach ($smwpcb_users_data_analytics_settings as $key => $users_data) {
                  $users_data_unserialised = unserialize($users_data->datausersarr);
                  ?>
                  <tr>
                  <th scope="row" class="check-column smwpcb_column_fix">
                      <input type="checkbox" class="checkedUserData" value="<?= esc_attr($users_data->id) ?>">
                  </th>
                  <td><strong><a title="<?= esc_attr($users_data_unserialised['date']) ?>" href="javascript:void(0)" key="<?= esc_attr($users_data->id) ?>" class="editDataUser datetitle"><?= esc_html(date('h:i A', strtotime($users_data_unserialised['date'])));?></a></strong>
                      <div class="row-actions">
                        <span class="edit">
                          <a href="javascript:void(0)" key="<?= esc_attr($users_data->uniquekey) ?>" class="editDataUser"><?php esc_html_e('Edit', 'smart-wordpress-chatbot'); ?></a> | </span>
                        <span class="trash">
                          <a href="javascript:void(0)" iduser="<?= esc_attr($users_data->id) ?>" key="<?= esc_attr($users_data->uniquekey) ?>" class="deleteDataUser"><?php esc_html_e('Trash', 'smart-wordpress-chatbot'); ?></a> </span>
                      </div>
                  </td>
                  <?php
                  for ($i=0; $i < count($smwpcb_data_tables_settings) ; $i++) {
                      ?>
                      <td>
                      <span><?= esc_html(stripslashes($users_data_unserialised[$i])) ?></span>
                      <input type="hidden" value="<?= esc_attr(stripslashes($users_data_unserialised[$i])) ?>">
                      </td>
                      <?php
                  }
                  ?>
                  <td>
                      <span><?= smwpcb_some_tags_to_html( esc_html(stripslashes($users_data_unserialised['datauserschoice'])) ) ?></span>
                      <input type="hidden" value="<?= esc_attr(stripslashes($users_data_unserialised['datauserschoice'])) ?>">
                      </td>
                  </tr>
                  <?php
                }
              }
              ?>
          </tbody>
          <tfoot>
            <tr>
                <td id="cb" class="manage-column column-cb check-column smwpcb_column_fix">
                    <label class="screen-reader-text" for="cb-select-all-1"><?php esc_html_e('Select All', 'smart-wordpress-chatbot'); ?></label>
                    <input id="cb-select-all-1" type="checkbox">
                </td>
                <th scope="col" class="manage-column sortable desc smwpcb_min_wdth"><a href="javascript:void(0)"><span><?php esc_html_e('Date', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span></a></th>
                <?php
                for ($k=0; $k < count($smwpcb_data_tables_settings) ; $k++) {
                ?>
                <th scope="col" class="manage-column sortable desc smwpcb_min_wdth"><a href="javascript:void(0)"><span><?= esc_html(stripslashes($smwpcb_data_tables_settings[$k]['name'])) ?></span><span class="sorting-indicator"></span> </a></th>
                <?php
                }
                ?>
                <th scope="col" class="manage-column sortable desc smwpcb_min_wdth"><a href="javascript:void(0)"><span><?php esc_html_e('Users responses', 'smart-wordpress-chatbot'); ?></span><span class="sorting-indicator"></span> </a></th>
            </tr>
          </tfoot>
        </table>
        <div class='tablenav-pages smwpcb_nav_page'><span class="displaying-num"><?= $numrows?> <?php esc_html_e('entries', 'smart-wordpress-chatbot'); ?></span>
          <?php
          if($currentpage == 1){
          ?>
             <span class='pagination-links'><span class="tablenav-pages-navspan button disabled" aria-hidden="true">&laquo;</span>
             <span class="tablenav-pages-navspan button disabled" aria-hidden="true">&lsaquo;</span>
           <?php
           }else{
            ?>
             <a class='next-page button' href='admin.php?page=smwpcb_wp_users_data&currentpage=1'><span class='screen-reader-text'><?php esc_html_e('Previous page', 'smart-wordpress-chatbot'); ?></span><span aria-hidden='true'>&laquo;</span></a>
            <a class='last-page button' href='<?php echo('admin.php?page=smwpcb_wp_users_data&currentpage='.($currentpage-1))?>'><span class='screen-reader-text'><?php esc_html_e('First page', 'smart-wordpress-chatbot'); ?></span><span aria-hidden='true'>&lsaquo;</span></a></span>
           <?php
           }
           ?>
           <span class="paging-input">
            
            <span class='tablenav-paging-text'><span class='total-pages'><?= $currentpage ?></span> of <span class='total-pages'><?= (($totalpages >=1) ? $totalpages : 1 ) ?></span></span>
           </span>

           <?php
          if($currentpage == $totalpages || $totalpages == 0){
          ?>
             <span class='pagination-links'><span class="tablenav-pages-navspan button disabled" aria-hidden="true">&rsaquo;</span>
             <span class="tablenav-pages-navspan button disabled" aria-hidden="true">&raquo;</span>
           <?php
           }else{
            ?>
             <a class='next-page button' href='<?php echo('admin.php?page=smwpcb_wp_users_data&currentpage='.($currentpage+1))?>'><span class='screen-reader-text'><?php esc_html_e('Next page', 'smart-wordpress-chatbot'); ?></span><span aria-hidden='true'>&rsaquo;</span></a>
            <a class='last-page button' href='<?php echo('admin.php?page=smwpcb_wp_users_data&currentpage='.$totalpages)?>'><span class='screen-reader-text'><?php esc_html_e('Last page', 'smart-wordpress-chatbot'); ?></span><span aria-hidden='true'>&raquo;</span></a></span>
           <?php
           }
           ?>
        </div>
        <form method="post" action="" class="smwpcb_form_download">
          <p class="submit" >
          <button type="submit" name="smwpcb_download_csv" class="button-primary" <?php if(count($smwpcb_users_data_analytics_settings) == 0) echo('disabled'); ?>><?php esc_html_e('Export to Excel Stylesheet', 'smart-wordpress-chatbot') ?></button> 
          </p>
        </form>
      </div>
      <?php

    }

}

/**
 * Export the excel version of the collected data
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_download_exported')){

    function smwpcb_download_exported() {

      if(isset($_POST['smwpcb_download_csv'])){
        smwpcb_export_to_excel('excel_users_data_'.uniqid());
        exit;
      }

    }

}

/**
 * Using the open source PHPExcel 
 * to generate an excel file from
 * the collected data.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_export_to_excel')){

    function smwpcb_export_to_excel( $filename ) {

      require_once SMWPCB_PLUGIN_DIR . '/libs/PHPExcel/Classes/PHPExcel/IOFactory.php';
      header('Content-type: application/vnd.ms-excel');
      header('Content-Disposition: attachment; filename="'.$filename.'.xlsx"');
      header("Pragma: no-cache"); 
      header("Expires: 0");
      $objPHPExcel = new PHPExcel();
      PHPExcel_Settings::setZipClass(PHPExcel_Settings::PCLZIP); 
      $objPHPExcel
          ->getProperties()
          ->setCreator("Climaxweb")
          ->setLastModifiedBy("Climaxweb")
          ->setTitle("Users Entries Collected From Maxbot");
      $objPHPExcel->setActiveSheetIndex(0);
      $sheet = $objPHPExcel->getActiveSheet();
      $headerColumns = array('Id','Date');
      $headerColumns = array_merge($headerColumns, smwpcb_get_all_table_columns_name());
      array_push($headerColumns, 'Users Responses');
      foreach ($headerColumns as $columnKey => $headerColumn) {
        $sheet->setCellValueByColumnAndRow($columnKey, 1, ($columnKey==0) ? 'Users Entries Collected From Maxbot' : '');
        $sheet->getStyleByColumnAndRow($columnKey, 1)->applyFromArray(
            array(
                'fill' => array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,
                    'color' => array('rgb' => 'ffffff')
                ),
                'font' => array(
                    'bold'  => false,
                    'color' => array('rgb' => '808080'),
                    'size'  => 20,
                    'name'  => 'Calibri'
                ),
                'alignment' => array(
                    'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                    'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                    'indent' => 1
                ),
                'borders' => array(
                    'allborders' => array(
                        'style' => PHPExcel_Style_Border::BORDER_THIN,
                        'color' => array('rgb' => 'ffffff')
                    )
                ),
            )
        );
        $sheet->getRowDimension('1')->setRowHeight(45);
        $sheet->setCellValueByColumnAndRow($columnKey, 2, ($columnKey==0) ? 'Document Generated on : '.date("Y/m/d") : '');
        $sheet->getStyleByColumnAndRow($columnKey, 2)->applyFromArray(
            array(
                'fill' => array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,
                    'color' => array('rgb' => 'ffffff')
                ),
                'font' => array(
                    'bold'  => false,
                    'color' => array('rgb' => '808080'),
                    'size'  => 18,
                    'name'  => 'Calibri'
                ),
                'alignment' => array(
                    'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                    'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                    'indent' => 1
                ),
                'borders' => array(
                    'allborders' => array(
                        'style' => PHPExcel_Style_Border::BORDER_THIN,
                        'color' => array('rgb' => 'ffffff')
                    )
                ),
            )
        );
        $sheet->getRowDimension('2')->setRowHeight(40);
        $sheet->setCellValueByColumnAndRow($columnKey, 3, strtoupper($headerColumn));
        $sheet->getStyleByColumnAndRow($columnKey, 3)->applyFromArray(
            array(
                'fill' => array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,
                    'color' => array('rgb' => '222b35')
                ),
                'font' => array(
                    'bold'  => true,
                    'color' => array('rgb' => 'ffffff'),
                    'size'  => 11,
                    'name'  => 'Century Gothic'
                ),
                'alignment' => array(
                    'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                    'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                    'indent' => 1
                ),
                'borders' => array(
                    'allborders' => array(
                        'style' => PHPExcel_Style_Border::BORDER_THIN,
                        'color' => array('rgb' => 'bfbfbf')
                    )
                ),
            )
        );
      }
      $sheet->getRowDimension('3')->setRowHeight(32);
      $smwpcb_users_data_analytics_settings = smwpcb_retrieve_all_users_data_analytics();
      $i = 4;
      foreach ($smwpcb_users_data_analytics_settings as $key => $users_data) {
        $sheet->getRowDimension(''.$i.'')->setRowHeight(32);
        $datausersarr = unserialize($users_data->datausersarr);
        $sheet->setCellValueByColumnAndRow(0, $i, $users_data->id);
        $sheet->setCellValueByColumnAndRow(1, $i, $datausersarr['date']);
        $sheet->getStyleByColumnAndRow(0, $i)->applyFromArray(
              array(
                  'fill' => array(
                      'type' => PHPExcel_Style_Fill::FILL_SOLID,
                      'color' => array('rgb' => 'd6dce4' )
                  ),
                  'font' => array(
                      'bold'  => false,
                      'color' => array('rgb' => '252e38'),
                      'size'  => 10,
                      'name'  => 'Century Gothic'
                  ),
                  'alignment' => array(
                      'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                      'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                      'indent' => 1
                  ),
                  'borders' => array(
                      'allborders' => array(
                          'style' => PHPExcel_Style_Border::BORDER_THIN,
                          'color' => array('rgb' => 'bfbfbf')
                      )
                  ),
              )
          );
        $sheet->getStyleByColumnAndRow(1, $i)->applyFromArray(
              array(
                  'fill' => array(
                      'type' => PHPExcel_Style_Fill::FILL_SOLID,
                      'color' => array('rgb' => 'f2f2f2' )
                  ),
                  'font' => array(
                      'bold'  => false,
                      'color' => array('rgb' => '252e38'),
                      'size'  => 10,
                      'name'  => 'Century Gothic'
                  ),
                  'alignment' => array(
                      'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                      'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                      'indent' => 1
                  ),
                  'borders' => array(
                      'allborders' => array(
                          'style' => PHPExcel_Style_Border::BORDER_THIN,
                          'color' => array('rgb' => 'bfbfbf')
                      )
                  ),
              )
          );
        for($j=2; $j<count(smwpcb_get_all_table_columns_name())+2;$j++){
          if(!isset($datausersarr[$j-2])){
            $sheet->setCellValueByColumnAndRow($j, $i, "NULL");
          }
          elseif ($datausersarr[$j-2] != ""){
            if(is_numeric($datausersarr[$j-2])){
              $sheet->getStyleByColumnAndRow($j, $i)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_TEXT);
            }
            $sheet->setCellValueByColumnAndRow($j, $i, stripslashes($datausersarr[$j-2]));
            $sheet->getCellByColumnAndRow($j, $i)->setHyperlink(null);
          }
          else{
            $sheet->setCellValueByColumnAndRow($j, $i, "");
          }
          $sheet->getStyleByColumnAndRow($j, $i)->applyFromArray(
              array(
                  'fill' => array(
                      'type' => PHPExcel_Style_Fill::FILL_SOLID,
                      'color' => array('rgb' => 'ffffff' )
                  ),
                  'font' => array(
                      'bold'  => false,
                      'color' => array('rgb' => '252e38'),
                      'size'  => 10,
                      'name'  => 'Century Gothic'
                  ),
                  'alignment' => array(
                      'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                      'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                      'indent' => 1
                  ),
                  'borders' => array(
                      'allborders' => array(
                          'style' => PHPExcel_Style_Border::BORDER_THIN,
                          'color' => array('rgb' => 'bfbfbf')
                      )
                  ),
              )
          );
        }
        $datausersarr['datauserschoice'] = str_replace("**","", $datausersarr['datauserschoice']);
        $datausersarr['datauserschoice'] = str_replace("\\","", $datausersarr['datauserschoice']);
        $datausersarr['datauserschoice'] = str_replace("\n","", $datausersarr['datauserschoice']);
        $sheet->setCellValueByColumnAndRow($j, $i, $datausersarr['datauserschoice']);  
        $sheet->getStyleByColumnAndRow($j, $i)->applyFromArray(
              array(
                  'fill' => array(
                      'type' => PHPExcel_Style_Fill::FILL_SOLID,
                      'color' => array('rgb' => 'ffffff')
                  ),
                  'font' => array(
                      'bold'  => false,
                      'color' => array('rgb' => '252e38'),
                      'size'  => 10,
                      'name'  => 'Century Gothic'
                  ),
                  'alignment' => array(
                      'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT,
                      'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
                      'indent' => 1
                  ),
                  'borders' => array(
                      'allborders' => array(
                          'style' => PHPExcel_Style_Border::BORDER_THIN,
                          'color' => array('rgb' => 'bfbfbf')
                      )
                  ),
              )
          );
        $i++;
      }
      $sheet->getColumnDimension('A')->setWidth(10);
      foreach (range('B', $sheet->getHighestDataColumn()) as $col) {
        $sheet->getColumnDimension($col)->setAutoSize(true);
      }
      $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
      $objWriter->save($filename.'.xlsx');
      $objWriter->save('php://output');

  }

}

/**
 * render strong and br tag, 
 * after escaping other html tags.
 * @since: 1.0.0
 **/
if (!function_exists('smwpcb_render_some_tags_to_html')){

    function smwpcb_some_tags_to_html( $string ) {

      $found_strong = false;
      for($i=0;$i<strlen($string)-1;$i++) {
          $char = $string[$i];
          $next_char = $string[$i+1];
          if($char == '*' && $next_char == '*') {
            $string = substr_replace($string, (!$found_strong) ? '<strong>' : '</strong>', $i, 0);
            $i = $i + strlen((!$found_strong) ? '<strong>' : '</strong>');
            $found_strong = (!$found_strong) ? true : false;
          }
          if(strpos($string, "\n") == $i) {
            $string = substr_replace($string, '<br>', $i, 0);
            $i = $i + 4;
          }
      }
      return str_replace('*', '', $string);

    }

}







?>